#define INVALID_SHIP_TYPE			1000
//#define INVALID_SHIP_TYPE			-1 //Change to SHIP_NOTUSED 1000

ref Fantom_GetNextFantom()
{
	iNumFantoms++;
	return &Characters[FANTOM_CHARACTERS + iNumFantoms];
}

int Fantom_GenerateEncounter(string sGroupName, object oResult, int iEType, int iNumWarShips, int iNumMerchantShips, int iNation) // NK
{
	//aref	aWar, aMerchant;
	//ref		rEnc;
	int		i;
	int		iWarClassMax, iWarClassMin, iMerchantClassMax, iMerchantClassMin;

	//makeref(rEnc, EncountersTypes[iEType]);
	//makearef(aWar, rEnc.War);
	//makearef(aMerchant, rEnc.Merchant);

	//iNumMerchantShips = MakeInt(aMerchant.ShipsMin) + rand(MakeInt(aMerchant.ShipsMax) - MakeInt(aMerchant.ShipsMin));
	//iNumWarShips = MakeInt(aWar.ShipsMin) + rand(MakeInt(aWar.ShipsMax) - MakeInt(aWar.ShipsMin));

	int iRank = sti(pchar.Rank);
	Encounter_GetClassesFromRank(iEType, iRank, &iMerchantClassMin, &iMerchantClassMax, &iWarClassMin, &iWarClassMax);

	int iFantomIndex, iShipType;

	for (i=0; i<iNumMerchantShips; i++)
	{
		iShipType = Fantom_GetShipType(iMerchantClassMin, iMerchantClassMax, "Merchant", iNation); // NK
		if (iShipType == INVALID_SHIP_TYPE) continue;
		Fantom_AddFantomCharacter(sGroupName, iShipType, "Trade", iEType);
	}
	for (i=0; i<iNumWarShips; i++)
	{
		iShipType = Fantom_GetShipType(iWarClassMin, iWarClassMax, "War", iNation); // NK
		if (iShipType == INVALID_SHIP_TYPE) continue;
		Fantom_AddFantomCharacter(sGroupName, iShipType, "War", iEType);
	}
	return iNumWarShips + iNumMerchantShips;
}
//#20190120-01
int Fantom_GetShipType(int iClassMin, int iClassMax, string sShipType, int iNation)
{
    return Fantom_GetShipTypeEnc(iClassMin, iClassMax, sShipType, iNation, true);
}

int Fantom_GetShipTypeEnc(int iClassMin, int iClassMax, string sShipType, int iNation, bool canEncounter)
{
	//Actually returns a "RealShip ID"
	int iShips[300]; //SHIP_TYPES_QUANTITY
	int i;
	int iShipsNum = 0;
	int iStart = SHIP_TARTANE;
	int iEnd = SHIP_CLASS_1_INDEX;

	//#20190121-03
	switch(iClassMin)
	{
	    case SHIP_CLASS_6:
            iStart = SHIP_CLASS_7_INDEX + 1;
            break;
        case SHIP_CLASS_5:
            iStart = SHIP_CLASS_6_INDEX + 1;
            break;
        case SHIP_CLASS_4:
            iStart = SHIP_CLASS_5_INDEX + 1;
            break;
        case SHIP_CLASS_3:
            iStart = SHIP_CLASS_4_INDEX + 1;
            break;
        case SHIP_CLASS_2:
            iStart = SHIP_CLASS_3_INDEX + 1;
            break;
        case SHIP_CLASS_1:
            iStart = SHIP_CLASS_2_INDEX + 1;
            break;
	}
	switch(iClassMax)
	{
	    case SHIP_CLASS_7:
            iEnd = SHIP_CLASS_7_INDEX;
            break;
        case SHIP_CLASS_6:
            iEnd = SHIP_CLASS_6_INDEX;
            break;
        case SHIP_CLASS_5:
            iEnd = SHIP_CLASS_5_INDEX;
            break;
        case SHIP_CLASS_4:
            iEnd = SHIP_CLASS_4_INDEX;
            break;
        case SHIP_CLASS_3:
            iEnd = SHIP_CLASS_3_INDEX;
            break;
        case SHIP_CLASS_2:
            iEnd = SHIP_CLASS_2_INDEX;
            break;
	}
//	Log_SetStringToLog("Encounter Nation = " + GetNationNameByType(iNation)); // MK
	for (i=iStart; i<=iEnd; i++)
	{
		ref rShip = GetShipByType(i);
		//#20201125-01
		if(CheckAttribute(rship, "delete")) continue;
		if (CheckAttribute(rship, "class"))
		{
			//int iClass = sti(rShip.Class);

			//if (iClass > iClassMin) { continue; }
			//if (iClass < iClassMax) { continue; }
			if (canEncounter && sti(rShip.CanEncounter) != true) { continue; }
			if (sti(rShip.Type.(sShipType)) != true) { continue; }
			// PB: Nation-Dependent Encounters -->
			if (iNation >= 0 && iNation < MAX_NATIONS) {
				string sNation = GetNationNameByType(iNation);
				if (CheckAttribute(rShip, sNation) && stf(rShip.(sNation)) < FRAND(1.0)) continue;
			}
		} // MK: Nation-Dependent Encounters <--
		else
		{
			if (CheckAttribute(rship, "name"))
				trace ("Fantom_GetShipType bad ship is: " + rship.name);
			else
				trace ("Fantom_GetShipType bad ship is: N/A, i = " + i);
		}
		iShips[iShipsNum] = i;
		iShipsNum++;
	}
	int iBaseShipType;
	if (iShipsNum==0)
	{
	    Trace("Fantom_GetShipTypeEnc Can't find ship type iStart = " + iStart + ", iEnd = " + iEnd);

	    iShipsNum = iStart + (iEnd - iStart);
		iBaseShipType = rand(iShipsNum);
	}
	else
    {
        iShipsNum--;
        i = rand(iShipsNum);
        iBaseShipType = iShips[i];
    }
	//trace(ShipsTypes[iBaseShipType].name);
	int iRealShipType = GenerateShip(iBaseShipType, 0);
	return iRealShipType;
}

// return new added fantom character
void Fantom_AddFantomCharacter(string sGroupName, int iShipType, string sFantomType, int iEncounterType)
{
	ref rFantom = GetFantomCharacter(iNumFantoms);

	DeleteAttribute(rFantom, "relation");
	DeleteAttribute(rFantom, "abordage_twice");
	DeleteAttribute(rFantom, "QuestDate");
	DeleteAttribute(rFantom, "ransom");

	//#20170912-02 Fix for RealShips/Character sails
    DeleteAttribute(rFantom, "ship.sails");
    DeleteAttribute(rFantom, "ship.upgrades");
    //#20170918-01 Fix for Abordage.Enable
    DeleteAttribute(rFantom, "Abordage.Enable");

	/*rFantom.fame = rand(70);

	int iNation = sti(rFantom.nation);
	//trace("Nation of Fantom is " + GetNationNameByType(iNation));
	iNation = FindEnemyNation2NationWithoutPirates(iNation);
	if(iNation != -1)
	{
		string sNation = GetNationNameByType(iNation);

		rFantom.reputation.(sNation) = 10;

		//trace("Nation of Enemy of Fantom is " + sNation);
		rFantom.bounty.(sNation).money = sti(rFantom.fame)*rand(500);
	}
	*/
	rFantom.SeaAI.Group.Name = sGroupName;
	rFantom.Ship.Type = iShipType;
	rFantom.Ship.Mode = sFantomType;
	rFantom.Charge.Type = GOOD_BALLS;

	iNumFantoms++;
}

void Fantom_SetRandomMoney(ref rFantom, string sFantomType)
{
	// clear money from character
	rFantom.Money = 0;

	//GenerateBootyItems(rFantom); // to_do del
	if (!CheckAttribute(rFantom, "ship.type")) return; // fix

    int iShip = sti(rFantom.ship.type);
	if (iShip == SHIP_NOTUSED) return; // fix

	// clear money from character
	rFantom.Money = 0;

	// ship class
	int iSClass = GetCharacterShipClass(rFantom);

	// add money
	switch (sFantomType)
	{
		case "trade":
			rFantom.Money = (10 - iSClass) * 100 + rand((10 - iSClass) * 800);
			return;
		break;
		case "war":
			rFantom.Money = (10 - iSClass) * 40 + rand((10 - iSClass) * 350);
			return;
		break;
		case "pirate":
		    rFantom.Money = (10 - iSClass) * 80 + rand((10 - iSClass) * 500);
			return;
		break;
	}
	//Trace("Fantom index = " + rFantom.index + ", group id = " + rFantom.SeaAI.Group.Name + ", have invalid encounter type = " + sFantomType);
}

int Fantom_CalcSkill(ref rMainCharacter, string sSkill, int iShipClass, int iSkillMin, int iSkillMax, int iSClass7, int iSClass6, int iSClass5, int iSClass4, int iSClass3, int iSClass2, int iSClass1)
// Stone-D : It was all backwards!
{
	int iSkill = GetSummonSkillFromName(rMainCharacter, sSkill);
    int minSkillLevel = 0;
	iSkill = iSkill + iSkillMin + rand(iSkillMax - iSkillMin);
	switch (iShipClass)
	{
		case 1: minSkillLevel =  iSClass1; break;
		case 2: minSkillLevel =  iSClass2; break;
		case 3: minSkillLevel =  iSClass3; break;
		case 4: minSkillLevel =  iSClass4; break;
		case 5: minSkillLevel =  iSClass5; break;
		case 6: minSkillLevel =  iSClass6; break;
		case 7: minSkillLevel =  iSClass7; break;
	}
	minSkillLevel = minSkillLevel*10;

    if (iSkill < minSkillLevel)	iSkill = minSkillLevel;
    if (iSkill < 1)		    	iSkill = 1;
	if (iSkill > SKILL_MAX)     iSkill = SKILL_MAX;
	return iSkill;
}

void Fantom_SetCannons(ref rFantom, string sFantomType)
{
	//int iSClass = GetCharacterShipClass(rFantom);
	ref rShip = GetRealShip(GetCharacterShipType(rFantom));

	int iCannonsType = sti(rShip.Cannon);
	if (iCannonsType == CANNON_TYPE_NONECANNON)
	{
		rFantom.Ship.Cannons.Type = CANNON_TYPE_NONECANNON;
		return;
	}
	string sCannonType = CANNON_WORD;
	int iCaliber = sti(rShip.MaxCaliber);
	int iMaxCaliber = iCaliber;
    switch(iCaliber)
	{
		case CANNON_BALL_WT_4:
			iCaliber = 0;
		break;
		case CANNON_BALL_WT_8:
			iCaliber = 1;
		break;
		case CANNON_BALL_WT_12:
			iCaliber = 2;
		break;
		case CANNON_BALL_WT_16:
			iCaliber = 3;
		break;
		case CANNON_BALL_WT_20:
			iCaliber = 4;
		break;
		case CANNON_BALL_WT_24:
			iCaliber = 5;
		break;
		case CANNON_BALL_WT_28:
			iCaliber = 6;
		break;
		case CANNON_BALL_WT_32:
			iCaliber = 7;
		break;
		case CANNON_BALL_WT_36:
			iCaliber = 8;
		break;
		case CANNON_BALL_WT_42:
			iCaliber = 9;
		break;
		case CANNON_BALL_WT_48:
			iCaliber = 10;
		break;
		case CANNON_BALL_WT_92:
			iCaliber = 11;
		break;
	}
	if (iCaliber > 0)
	{
	   iCaliber = iCaliber - rand(1);
	}
	switch(iCaliber)
	{
		case 0:
			iCaliber = CANNON_BALL_WT_4;
		break;
		case 1:
			iCaliber = CANNON_BALL_WT_8;
		break;
        	case 2:
			iCaliber = CANNON_BALL_WT_12;
		break;
		case 3:
			iCaliber = CANNON_BALL_WT_16;
		break;
		case 4:
			iCaliber = CANNON_BALL_WT_20;
		break;
		case 5:
			iCaliber = CANNON_BALL_WT_24;
		break;
		case 6:
			iCaliber = CANNON_BALL_WT_28;
		break;
		case 7:
			iCaliber = CANNON_BALL_WT_32;
		break;
		case 8:
			iCaliber = CANNON_BALL_WT_36;
		break;
		case 9:
			iCaliber = CANNON_BALL_WT_42;
		break;
		case 10:
			iCaliber = CANNON_BALL_WT_48;
		break;
		case 11:
			iCaliber = CANNON_BALL_WT_92;
		break;
	}
	if (iCaliber < CANNON_BALL_WT_4)
	{
	   iCaliber = CANNON_BALL_WT_4;
	}
    if (iCaliber > iMaxCaliber) { iCaliber=iMaxCaliber; }

	switch (sFantomType)
	{
        case "trade":
            if (rand(1000) > 699)
		    {
			   sCannonType = CULVERINE_WORD;
			}
		break;
		case "war":
			if (rand(1000) > 199)
		    {
			   sCannonType = CULVERINE_WORD;
			}
		    break;
		case "pirate":
			if (rand(1000) > 399)
		    {
			   sCannonType = CULVERINE_WORD;
			}
		    break;
	}
	if (iCaliber > CANNON_BALL_WT_32)
	{
	    sCannonType = CANNON_WORD;
	}
	rFantom.Ship.Cannons.Type = GetCannonByTypeAndCaliber(sCannonType, iCaliber);
}

void Fantom_SetSails(ref rFantom, string sFantomType)
{
	rFantom.Ship.Sails.Gerald = false;
	if (sFantomType == "war") rFantom.Ship.Sails.Gerald = true;
}

void Fantom_SetBalls(ref rFantom, string sFantomType)
{
	float fKBase = SHIP_CLASS_7 - GetCharacterShipClass(rFantom);
	if (fKBase <= 0) fKBase = 0.7;
	if (GetCharacterShipClass(rFantom) == 1) fKBase = fKBase * 1.6;

	float fKBalls;
	int ecrew = makeint(GetCrewQuantity(rFantom));// ADDED on 27.12.2022 by Vadim C.

	switch (sFantomType)
	{
		case "war":
			fKBalls = fKBase * 1.0;
		break;
		case "trade":
			fKBalls = fKBase * 0.7;
		break;
		case "pirate":
			fKBalls = fKBase * 1.0;
		break;
	}
	if (Realistic_Reloading) {
		// JA, fix for ships running out of ammo on realistic settings
		fKBalls = fKBalls * 3;
	}
	
	Fantom_SetCharacterGoods(rFantom, GOOD_BALLS,    MakeInt(150 * fKBalls + rand(MakeInt(10 * fKBalls))));// EDITED on 27.12.2022 by Vadim C.
	Fantom_SetCharacterGoods(rFantom, GOOD_BOMBS,    MakeInt(120 * fKBalls + rand(MakeInt(20 * fKBalls))));// EDITED on 27.12.2022 by Vadim C.
	Fantom_SetCharacterGoods(rFantom, GOOD_KNIPPELS, MakeInt(90 * fKBalls + rand(MakeInt(10 * fKBalls))));
	Fantom_SetCharacterGoods(rFantom, GOOD_GRAPES,   MakeInt(70 * fKBalls + rand(MakeInt(10 * fKBalls))));
	Fantom_SetCharacterGoods(rFantom, GOOD_POWDER,   MakeInt(350 * fKBalls + rand(MakeInt(30 * fKBalls))));

	Fantom_SetCharacterGoods(rFantom, GOOD_SAILCLOTH, MakeInt(4 * fKBase + rand(MakeInt(10 * fKBalls))));
	Fantom_SetCharacterGoods(rFantom, GOOD_PLANKS, MakeInt(3 * fKBase + rand(MakeInt(20 * fKBalls))));

    Fantom_SetCharacterGoods(rFantom, GOOD_FOOD, MakeInt(8 * fKBase  + rand(MakeInt(26 * fKBalls)))));
    //Fantom_SetCharacterGoods(rFantom, GOOD_WEAPON, MakeInt(6 * fKBase + rand(MakeInt(13 * fKBalls))));// DISABLED on 27.12.2022 by Vadim C.
    Fantom_SetCharacterGoods(rFantom, GOOD_WEAPON, sti(ecrew - rand(makeint(ecrew / 4))));// ADDED on 27.12.2022 by Vadim C.
    Fantom_SetCharacterGoods(rFantom, GOOD_RUM, MakeInt(2 * fKBase  + rand(MakeInt(10 * fKBalls)))));
    Fantom_SetCharacterGoods(rFantom, GOOD_MEDICAMENT, MakeInt(3 * fKBase + rand(MakeInt(13 * fKBalls))));
	// ADDED (BELOW) on 27.12.2022 by Vadim C., for testing purposes only to see what the original values were.
	//Log_Info("A) Weapons: "+(MakeInt(6 * fKBase + rand(MakeInt(13 * fKBalls))))
	//+" // Crew: "+GetCrewQuantity(rFantom)+" :: "+GetWeaponCrew(rFantom, GetCrewQuantity(rFantom)));
}
//#20181030-01
void Fantom_SetBallsFishing(ref rFantom)
{
	float fKBase = SHIP_CLASS_7 - GetCharacterShipClass(rFantom);
	if (fKBase <= 0) fKBase = 0.7;
	if (GetCharacterShipClass(rFantom) == 1) fKBase = fKBase * 1.6;

	float fKBalls;
	int ecrew = makeint(GetCrewQuantity(rFantom));// ADDED on 27.12.2022 by Vadim C.

	fKBalls = fKBase * 0.5; //Always trade type
	Fantom_SetCharacterGoods(rFantom, GOOD_BALLS,    MakeInt(45 * fKBalls + rand(MakeInt(10 * fKBalls))));
	Fantom_SetCharacterGoods(rFantom, GOOD_KNIPPELS, MakeInt(45 * fKBalls + rand(MakeInt(10 * fKBalls))));
	Fantom_SetCharacterGoods(rFantom, GOOD_POWDER,   MakeInt(100 * fKBalls + rand(MakeInt(30 * fKBalls))));

    Fantom_SetCharacterGoods(rFantom, GOOD_FOOD, MakeInt(8 * fKBase  + rand(MakeInt(26 * fKBalls)))));
    //Fantom_SetCharacterGoods(rFantom, GOOD_WEAPON, MakeInt(6 * fKBase + rand(MakeInt(13 * fKBalls))));// DISABLED on 27.12.2022 by Vadim C.
    Fantom_SetCharacterGoods(rFantom, GOOD_WEAPON, sti(ecrew - rand(makeint(ecrew / 4))));// ADDED on 27.12.2022 by Vadim C.
    Fantom_SetCharacterGoods(rFantom, GOOD_RUM, MakeInt(2 * fKBase  + rand(MakeInt(10 * fKBalls)))));
    Fantom_SetCharacterGoods(rFantom, GOOD_MEDICAMENT, MakeInt(3 * fKBase + rand(MakeInt(13 * fKBalls))));
	// ADDED (BELOW) on 27.12.2022 by Vadim C., for testing purposes only to see what the original values were.
	//Log_Info("B) Weapons: "+(MakeInt(6 * fKBase + rand(MakeInt(13 * fKBalls))))
	//+" // Crew: "+GetCrewQuantity(rFantom)+" :: "+GetWeaponCrew(rFantom, GetCrewQuantity(rFantom)));
}

void Fantom_SetGoods(ref rFantom, string sFantomType)
{
 	int iMultiply = 10;
	int iRandMultiply = 1;
    int iShipClass = SHIP_CLASS_7 - GetCharacterShipClass(rFantom);
    int iStart = GOOD_PLANKS + 1;
    int iFinish = GOOD_CANNON_12 - iStart - 1;
    int i, iGoods;
	switch (sFantomType)
	{
		case "war":
		    iMultiply = (rand(5)+5) * (rand(iShipClass) + 1);
			iRandMultiply = 1 + rand(iShipClass);
			for (i = 0; i < 3; i++)
			{
			    Fantom_SetCharacterGoods(rFantom, iStart + rand(iFinish), iMultiply * rand(iRandMultiply * 3));
			}
		break;
		case "trade":
			if (CheckAttribute(rFantom, "RealEncounterType") && sti(rFantom.RealEncounterType) == ENCOUNTER_TYPE_ESCORT_LARGE)
			{
                iMultiply = (rand(10)+ 30) * (rand(iShipClass) + 2);
            	iRandMultiply = 2 + rand(iShipClass);
				if (rand(1) == 0)
				{
					Fantom_SetCharacterGoods(rFantom, GOOD_GOLD, 50 + iMultiply * (1 + rand(iRandMultiply * 3)));
				}
				else
				{
		        	Fantom_SetCharacterGoods(rFantom, GOOD_SILVER, 100 + iMultiply * (1 + rand(iRandMultiply * 3)));
		        }
			}
			else
			{
                iGoods = 8;
				if (CheckAttribute(rFantom, "RealEncounterType") && sti(rFantom.RealEncounterType) == ENCOUNTER_TYPE_MERCHANT_LARGE)
                {
                    iGoods = 11;
                }
				iMultiply = (rand(10)+iGoods*3) * (rand(iShipClass) + 4);
            	iRandMultiply = 2 + rand(iShipClass);
				for (i = 0; i < iGoods; i++)
				{
				    Fantom_SetCharacterGoods(rFantom, iStart + rand(iFinish), iMultiply * (1+rand(iRandMultiply * 3)));
				}
			}
		break;
		case "pirate":
			iMultiply = (rand(10)+3) * (rand(iShipClass) + 1);
			iRandMultiply = 2 + rand(iShipClass);
			for (i = 0; i < 4; i++)
			{
			    Fantom_SetCharacterGoods(rFantom, iStart + rand(iFinish), iMultiply * rand(iRandMultiply * 3));
			}
		break;
	}
    iMultiply = GetCannonGoodsIdxByType(sti(rFantom.Ship.Cannons.Type));
    if (iMultiply != -1)
    {
    	iRandMultiply = rand(6) - 2;  // 0..4
    	if (iRandMultiply > 0)
    	{
    		Fantom_SetCharacterGoods(rFantom, iMultiply, iRandMultiply);
    	}
    }
    RecalculateCargoLoad(rFantom);
}

int Fantom_SetCharacterGoods(ref rFantom, int iGoods, int iQuantity)
{
	if (iQuantity == 0) { return 0; }

	string sGood = Goods[iGoods].name;
	int iFreeQuantity = GetGoodQuantityByWeight( iGoods, GetCargoFreeSpace(rFantom) );
	if (iFreeQuantity < 0) { iFreeQuantity = 0; }

	if (iQuantity > iFreeQuantity) { iQuantity = iFreeQuantity; }
    rFantom.Ship.Cargo.Goods.(sGood) = iQuantity;

	RecalculateCargoLoad(rFantom);
	return iQuantity;
}

void Fantom_SetRandomCrewExp(ref rFantom, string sFantomType)
{
    if (!CheckAttribute(rFantom, "ship.type")) return; // fix

	int iShip = sti(rFantom.ship.type);
	if (iShip == SHIP_NOTUSED) return; // fix

	// ship class
	int iSClass = GetCharacterShipClass(rFantom);

	switch (sFantomType)
	{
		case "trade":
			rFantom.Ship.Crew.Exp.Sailors   = 20 - iSClass*2 + MOD_SKILL_ENEMY_RATE + rand(70);
			rFantom.Ship.Crew.Exp.Cannoners = 20 - iSClass*2 + MOD_SKILL_ENEMY_RATE + rand(70);
			rFantom.Ship.Crew.Exp.Soldiers  = 20 - iSClass*2 + MOD_SKILL_ENEMY_RATE + rand(70);
		break;
		case "war":
			rFantom.Ship.Crew.Exp.Sailors   = 30 - iSClass*2 + MOD_SKILL_ENEMY_RATE + rand(60);
			rFantom.Ship.Crew.Exp.Cannoners = 30 - iSClass*2 + MOD_SKILL_ENEMY_RATE + rand(60);
			rFantom.Ship.Crew.Exp.Soldiers  = 30 - iSClass*2 + MOD_SKILL_ENEMY_RATE + rand(60);
		break;
		case "pirate":
		    rFantom.Ship.Crew.Exp.Sailors   = 35 - iSClass*2 + MOD_SKILL_ENEMY_RATE + rand(55);
			rFantom.Ship.Crew.Exp.Cannoners = 35 - iSClass*2 + MOD_SKILL_ENEMY_RATE + rand(55);
			rFantom.Ship.Crew.Exp.Soldiers  = 35 - iSClass*2 + MOD_SKILL_ENEMY_RATE + rand(55);
		break;
	}
}
//#29220910-01
void SetShipToFantom(ref _chr, string _type, bool _setgoods)
{
    int Rank = sti(pchar.rank);
    SetShipToFantomByRank(_chr, Rank, _type, _setgoods);
}

void SetShipToFantomByRank(ref _chr, int Rank, string _type, bool _setgoods)
{
//	Log_SetStringToLog("Function SetShipToFantom executed for character" + _chr.id);
    //#20190121-03
    int iShips[300]; //SHIP_TYPES_QUANTITY
	int ShipType, i;
	int iShipsNum = 0;
	int iNation = sti(_chr.nation);
	//int Rank = sti(pchar.rank);
	bool bLimitTrade = false;
	bool bCanEncounter = false;
	int iClassLimit = SHIP_CLASS_6_INDEX;

	//#20190121-03
	if(_type == "trade")
    {
        bLimitTrade = true;
        bCanEncounter = true;
    }
    if (Rank >= 11 && Rank <= 20)
		iClassLimit = SHIP_CLASS_5_INDEX;
    if (Rank > 20)
		iClassLimit = SHIP_CLASS_4_INDEX;

	for (i=(SHIP_CLASS_7_INDEX + 1); i<=iClassLimit; i++)
	{
		ref rShip = GetShipByType(i);
		//#20201125-01
		if(CheckAttribute(rship, "delete")) continue;
		if (CheckAttribute(rship, "class"))
		{
			if (bCanEncounter && sti(rShip.CanEncounter) != true) { continue; }
			if (bLimitTrade && sti(rShip.Type.Merchant) != true) { continue; }
			if (iNation >= 0 && iNation < MAX_NATIONS) {
				string sNation = GetNationNameByType(iNation);
				if (CheckAttribute(rShip, sNation) && stf(rShip.(sNation)) < FRAND(1.0)) continue;
			}
		}
		else
		{
			if (CheckAttribute(rship, "name"))
				trace ("SetShipToFantom bad ship is: " + rship.name);
			else
				trace ("SetShipToFantom bad ship is: N/A, i = " + i);
		}
		iShips[iShipsNum] = i;
		iShipsNum++;
	}
	if (iShipsNum==0)
	{
		Trace("SetShipToFantom Can't find ship type");
		ShipType = rand(SHIP_CLASS_7_INDEX + (iClassLimit - SHIP_CLASS_7_INDEX));
	}
	else {
        ShipType = iShips[rand(iShipsNum-1)];
	}
	_chr.Ship.Type = GenerateShip(ShipType, true);

	SetRandomNameToShip(_chr);
    SetBaseShipData(_chr);
    //SetCrewQuantityFull(_chr);
    //#20210727-01
    SetVariableCrew(_chr);
    Fantom_SetCannons(_chr, _type);
    Fantom_SetBalls(_chr, _type);
    if (_setgoods)
    {
        Fantom_SetGoods(_chr, _type);
    }
}
