#define FELLOWTRAVEL_NO			0
#define FELLOWTRAVEL_CAPTIVE	1
#define FELLOWTRAVEL_PASSENGER	2
#define FELLOWTRAVEL_OFFICER	3
#define FELLOWTRAVEL_COMPANION	4

#define EVENT_CHANGE_OFFICERS	"EvntChangeOfficers"
#define EVENT_CHANGE_COMPANIONS	"EvntChangeCompanions"

#define MAX_ITEM_TAKE	5000

#define MSGICON_ACTIVE_TIME 10
#define MSGICON_LEVELUP	0
#define MSGICON_LOGBOOK	1
#define MSGICON_GETITEM	2

//Boyer add #20170318-54
#define GUN_SPEED_BASE 10.0
#define GUN_MIN_WT 0.75
#define GUN_MAX_WT 0.5

//#20180109-02 Gun charge max
#define GUN_CHARGE_MAX 6

//Boyer add #20170318-20
int MAX_NUM_FIGHTERS = 6; // Range from 3 to 8...or ???

//Boyer remove, useless in Storm 2.8
//#event_handler("evnt_MsgIconTick","proc_MsgIconTick");

bool GetShipRemovable(ref _refCharacter)
{
	if( CheckAttribute(_refCharacter,"ShipRemovable") && sti(_refCharacter.ShipRemovable) == false )
	{
		return false;
	}
	return true;
}

bool GetShipRemovableEx(ref _refCharacter)
{
	if(GetShipRemovable(_refCharacter) == false && _refCharacter.id != pchar.id)
	{
		return false;
	}
	return true;
}

void SetShipRemovable(ref _refCharacter, bool bRemovable)
{
	if(bRemovable)
	{
		DeleteAttribute(_refCharacter,"ShipRemovable");
	}
	else
	{
		_refCharacter.ShipRemovable = false;
	}
}

bool CharacterIsDead(ref _refCharacter)
{
	return LAi_IsDead(_refCharacter);
}

bool IsCompanion(ref _refCharacter)
{
    if(!CheckAttribute(_refCharacter , "index")) return false;
	int findIdx = sti(_refCharacter.index);
	ref mc = GetMainCharacter();
	for(int i=0; i<COMPANION_MAX; i++)
	{
		if(GetCompanionIndex(mc,i)==findIdx) return true;
	}
	return false;
}

bool IsOfficer(ref _refCharacter)
{
	int findIdx = sti(_refCharacter.index);
	ref mc = GetMainCharacter();
	//#20170318-20
	for(int i=0; i<=MAX_NUM_FIGHTERS; i++)
	{
		if(GetOfficersIndex(mc,i)==findIdx) return true;
	}
	return false;
}

void SetCharacterRemovable(ref _refCharacter,bool removable)
{
	if(removable) DeleteAttribute(_refCharacter,"NonRemovable");
	else _refCharacter.NonRemovable = true;
}

bool GetRemovable(ref _refCharacter)
{
	if( CheckAttribute(_refCharacter,"NonRemovable") ) return !sti(_refCharacter.NonRemovable);
	return true;
}

// Cargo utilites
int GetCargoLoad(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Cargo.Load")) return 0;
	int iLoad = sti(_refCharacter.Ship.Cargo.Load);
	return iLoad;
}

int GetCargoLoadEx(ref _refCharacter, int addGoods, int iGoods)
{
	int iGoodsQ = addGoods;
	if(iGoodsQ < 0)
	{
		iGoodsQ = -iGoodsQ;
	}
	iGoodsQ = GetGoodWeightByType(iGoods, iGoodsQ);//addGoods / sti(Goods[iGoods].units);

	int iLoad;

	if(addGoods < 0)
	{
		iLoad = GetCargoLoad(_refCharacter) - iGoodsQ;
	}
	else
	{
		iLoad = GetCargoLoad(_refCharacter) + iGoodsQ;
	}
	return iLoad;
}

int RecalculateCargoLoad(ref _refCharacter)
{
	int loadSpace = 0;
	if (sti(_refCharacter.Ship.Cannons.Type) != CANNON_TYPE_NONECANNON)
	{
		ref Cannon = GetCannonByType(sti(_refCharacter.Ship.Cannons.Type));
		loadSpace = GetCannonsNum(_refCharacter) * sti(Cannon.Weight);
	}
	for(int i=0; i<GOODS_QUANTITY; i++)
	{
		loadSpace = loadSpace + GetGoodWeightByType(i,GetCargoGoods(_refCharacter,i));
	}
	_refCharacter.Ship.Cargo.Load = loadSpace;
	return loadSpace;
}

int GetCargoFreeSpace(ref _refCharacter)
{
	int freeSpace = GetCargoMaxSpace(_refCharacter) - GetCargoLoad(_refCharacter);
	if (freeSpace < 0) freeSpace = 0;  // fix
	return freeSpace;
}

int GetCargoMaxSpace(ref _refCharacter)
{
	if( !CheckAttribute(_refCharacter,"Ship.Type") ) return 0;
	int _ShipType = sti(_refCharacter.Ship.Type);
	if( _ShipType==SHIP_NOTUSED )
		return 0;
	return sti(RealShips[_ShipType].Capacity);
}

int GetCharacterFreeSpace(ref _refCharacter,int _Goods)
{
	int g = GetGoodQuantityByWeight( _Goods, GetCargoFreeSpace(_refCharacter) );
	if (g < 0) g = 0; // fix
	return g;
}

int GetSquadronFreeSpace(ref _refCharacter,int _Goods)
{
	float weight = stf(Goods[_Goods].weight);
	if(weight==0.0) weight = 0.00001;
	int unitQ = sti(Goods[_Goods].Units);

	int retVal = unitQ * (GetCargoFreeSpace(_refCharacter)/weight);
	int i,cn;
	ref chref;
	for(i=1; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
  		if(cn!=-1 && GetRemovable(&Characters[cn]))//fix
		{
			chref = GetCharacter(cn);
			//if(GetShipRemovableEx(chref))
			//{
				retVal = retVal + unitQ*(GetCargoFreeSpace(chref)/weight);
			//}
		}
	}
	if (retVal < 0) retVal = 0; // fix
	return retVal;
}

int GetCargoGoods(ref _refCharacter,int _Goods)
{
	string goodsName = Goods[_Goods].name;
	if(!CheckAttribute(_refCharacter,"Ship.Cargo.Goods."+goodsName))
		return 0;
	return sti(_refCharacter.Ship.Cargo.Goods.(goodsName));
}

int GetSquadronGoods(ref _refCharacter,int _Goods)
{
	int i,cn;
	ref chref;
	int retVal = GetCargoGoods(_refCharacter,_Goods);
	for(i=1; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if(cn!=-1 && GetRemovable(&Characters[cn]))//fix
		{
			chref = GetCharacter(cn);
			if( GetShipRemovableEx(chref) )
			{
				retVal = retVal + GetCargoGoods(chref,_Goods);
			}
		}
	}
	return retVal;
}

void SetCharacterGoods(ref _refCharacter,int _Goods,int _Quantity)
{
	string goodsName = Goods[_Goods].name;
	_refCharacter.Ship.Cargo.Goods.(goodsName) = _Quantity;
	int curLoad = RecalculateCargoLoad(_refCharacter);
	int maxLoad = GetCargoMaxSpace(_refCharacter);
	if(curLoad>maxLoad)
	{
		Trace("ERROR! Cargo space overup (character=" + _refCharacter.index + ",Quantity=" + _Quantity + ")");
	}
}

int RemoveCharacterGoodsSelf(ref _refCharacter,int _Goods,int _Quantity)
{
	int    curQuantity;
	string goodsName = Goods[_Goods].name;

	curQuantity = sti( _refCharacter.Ship.Cargo.Goods.(goodsName) );
	if (curQuantity>=_Quantity)
	{
		_refCharacter.Ship.Cargo.Goods.(goodsName) = curQuantity - _Quantity;
		RecalculateCargoLoad(_refCharacter);
		return true;
	}
	_refCharacter.Ship.Cargo.Goods.(goodsName) = 0;
	//_Quantity = _Quantity - curQuantity;
	RecalculateCargoLoad(_refCharacter);
	return false;
}

int AddCharacterGoodsSimple(aref aCharacter, int iGood, int iQuantity)
{
	string sGoodName = Goods[iGood].name;
	int    freeQuantity;

	freeQuantity = GetGoodQuantityByWeight(iGood, GetCargoFreeSpace(aCharacter));
	if (freeQuantity < 0) freeQuantity = 0; //fix
	if (freeQuantity > iQuantity)
	{
		freeQuantity = iQuantity;
	}
	aCharacter.Ship.Cargo.Goods.(sGoodName) = sti(aCharacter.Ship.Cargo.Goods.(sGoodName)) + freeQuantity;
	RecalculateCargoLoad(aCharacter);
	return freeQuantity;
}

int AddCharacterGoods(ref _refCharacter,int _Goods,int _Quantity)
{
	int i,cn,freeQuantity;
	string goodsName = Goods[_Goods].name;

	for (i=0; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if (cn!=-1 && GetRemovable(&Characters[cn]))//fix
		{
			freeQuantity = GetGoodQuantityByWeight( _Goods, GetCargoFreeSpace(&Characters[cn]) );
			if(freeQuantity>=_Quantity)
			{
				Characters[cn].Ship.Cargo.Goods.(goodsName) = sti(Characters[cn].Ship.Cargo.Goods.(goodsName)) + _Quantity;
				RecalculateCargoLoad(&Characters[cn]);
				return true;
			}
			Characters[cn].Ship.Cargo.Goods.(goodsName) = sti(Characters[cn].Ship.Cargo.Goods.(goodsName)) + freeQuantity;
			_Quantity = _Quantity - freeQuantity;
			RecalculateCargoLoad(&Characters[cn]);
		}
	}
	Trace("Overup cargo space on "+_Quantity + " id = " + _refCharacter.id);
	return false;
}

int RemoveCharacterGoods(ref _refCharacter,int _Goods,int _Quantity)
{
	int i,cn,curQuantity;
	string goodsName = Goods[_Goods].name;

	for(i=0; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if (cn!=-1 && GetRemovable(&Characters[cn]))//fix
		{
            if (CheckAttribute(&Characters[cn], "Ship.Cargo.Goods."+goodsName))
            {
                curQuantity = sti( Characters[cn].Ship.Cargo.Goods.(goodsName) );
    			if(curQuantity>=_Quantity)
    			{
    				Characters[cn].Ship.Cargo.Goods.(goodsName) = curQuantity - _Quantity;
    				RecalculateCargoLoad(&Characters[cn]);
    				return true;
    			}
    			Characters[cn].Ship.Cargo.Goods.(goodsName) = 0;
    			_Quantity = _Quantity - curQuantity;
    			RecalculateCargoLoad(&Characters[cn]);
			}
			else
			{
                if (MOD_BETTATESTMODE == "On") Log_TestInfo("No cargo goods: RemoveCharacterGoods characterID = "+ Characters[cn].id);
			}
		}
	}
	Trace("Overup cargo space on "+_Quantity);
	return false;
}
// Cannons utilite
int GetCaracterShipCannonsType(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Cannons.Type")) return CANNON_TYPE_NONECANNON;
	return sti(_refCharacter.Ship.Cannons.Type);
}
int GetCannonQuantity(ref refCharacter)
{
	int nShipType = GetCharacterShipType(refCharacter);
	if(nShipType==SHIP_NOTUSED) return 0;
	ref rShip = GetRealShip(nShipType);
	return sti(rShip.CannonsQuantity);
}

int GetIntactCannonQuantity(ref refCharacter)
{
	int nShipType = GetCharacterShipType(refCharacter);
	if(nShipType==SHIP_NOTUSED) return 0;
	ref refBaseShip = GetRealShip(nShipType);

	int canQ = GetBortIntactCannonsNum(refCharacter, "cannonf", sti(refBaseShip.fcannon)) + GetBortIntactCannonsNum(refCharacter, "cannonb", sti(refBaseShip.bcannon)) + GetBortIntactCannonsNum(refCharacter, "cannonl", sti(refBaseShip.lcannon)) + GetBortIntactCannonsNum(refCharacter, "cannonr", sti(refBaseShip.rcannon));
	return canQ;
}

int GetMaximumCaliber(ref refCharacter)
{
	int nShipType = GetCharacterShipType(refCharacter);
	if(nShipType==SHIP_NOTUSED) return 0;
	ref rShip = GetRealShip(nShipType);
	return sti(rShip.MaxCaliber);
}

// Ship utilite
int GetCharacterShipType(ref _refCharacter)
{
	if(CheckAttribute(_refCharacter,"Ship.Type"))
	{
		int iShipType = sti(_refCharacter.Ship.Type);
		if(iShipType != SHIP_NOTUSED)
		{
            return iShipType;
			/*
			int iRealShipType = sti(RealShips[iShipType].basetype);
			if(iRealShipType == SHIP_BOAT)
			{
				return iShipType;
			}
			if(iRealShipType >=0 && iRealShipType < SHIP_TYPES_QUANTITY_WITH_FORT)
			{
				return iShipType;
			} */
		}
	}
	return SHIP_NOTUSED;
}
int GetCharacterShipHP(ref _refCharacter)
{
	int nShipType = GetCharacterShipType(_refCharacter);
	if(nShipType==SHIP_NOTUSED) return 0;
	return sti(RealShips[nShipType].HP);
}
int GetCurrentShipHP(ref _refCharacter)
{
	if( CheckAttribute(_refCharacter,"ship.hp") ) return sti(_refCharacter.ship.hp);
	return 0;
}
float GetCharacterShipSP(ref _refCharacter)
{
	int nShipType = GetCharacterShipType(_refCharacter);
	if(nShipType==SHIP_NOTUSED) return 0.0;
	return stf(RealShips[nShipType].SP);
}
string GetShipTypeName(ref _refCharacter)
{
	int nShipType = GetCharacterShipType(_refCharacter);
	if(nShipType==SHIP_NOTUSED)
	{
		return SHIP_NOTUSED_TYPE_NAME;
	}

	return ShipsTypes[sti(RealShips[nShipType].basetype)].name;
}
int GetCharacterShipClass(ref _refCharacter)
{
	int nShipType = GetCharacterShipType(_refCharacter);
	if( nShipType==SHIP_NOTUSED ) return SHIP_CLASS_7;
	//Boyer add trace if no good...
	if(!CheckAttribute(RealShips[nShipType], "class")) {
		Trace("No good ship class from GetCharacterShipClassp, nShipType = " + nShipType +
		      "_refCharacter.id = " + _refCharacter.id);
	}
	return sti(RealShips[nShipType].Class);
}
int GetMaxCrewQuantity(ref _refCharacter)
{
	if(CheckAttribute(_refCharacter,"storenum")) return 99999;

	if(!CheckAttribute(_refCharacter,"Ship.Type")) return 0;
	int shipType = sti(_refCharacter.Ship.Type);
	if(shipType<0) return 0;
    if(shipType>=REAL_SHIPS_QUANTITY) return 0;
	return sti(RealShips[shipType].MaxCrew);
}
//optimal crew
int GetOptCrewQuantity(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Type")) return 0;
	int shipType = sti(_refCharacter.Ship.Type);
	if(shipType<0) return 0;
	if(shipType>=REAL_SHIPS_QUANTITY) return 0;
	return sti(RealShips[shipType].OptCrew);
}

int GetMinCrewQuantity(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Type")) return 0;
	int shipType = sti(_refCharacter.Ship.Type);
	if(shipType<0) return 0;
	if(shipType>=REAL_SHIPS_QUANTITY) return 0;
	return sti(RealShips[shipType].MinCrew);
}
int GetFreeCrewQuantity(ref _refCharacter)
{
	return (GetMaxCrewQuantity(_refCharacter)-GetCrewQuantity(_refCharacter));
}
int GetFreePartyCrewQuantity(ref _refCharacter)
{
	int cn;
	int sumCrew = 0;
	for(int i=0; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if(cn!=-1)
		{
			sumCrew = sumCrew + GetFreeCrewQuantity(GetCharacter(cn));
		}
	}
	return sumCrew;
}
int GetCrewQuantity(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Crew.Quantity")) return 0;
	if (sti(_refCharacter.Ship.Crew.Quantity) < 0) _refCharacter.Ship.Crew.Quantity = 0;

	return sti(_refCharacter.Ship.Crew.Quantity);
}
int SetCrewQuantity(ref _refCharacter,int num)
{
	int maxCrew = GetMaxCrewQuantity(_refCharacter);
	if(num>maxCrew)
	{
		Trace("Error!!! Overup maximum crew quantity (character=" + _refCharacter.index + ")");
		_refCharacter.Ship.Crew.Quantity = maxCrew;
		return false;
	}
	if (num < 0) num = 0; // fix
	_refCharacter.Ship.Crew.Quantity = num;
	return true;
}
//#20210727-01
int GetVariableCrew(ref _chr)
{
    float maxCrew = makefloat(GetMaxCrewQuantity(_chr));
    int nRand = rand(99);
    int nRet = maxCrew;

    if(nRand < 49) {
        nRet = makeint(maxCrew * (0.5 + frand(0.2)));
    }
    else {
        if(nRand < 74)
            nRet = makeint(maxCrew * 0.33);
    }
    return nRet;
}

void SetVariableCrew(ref _chr)
{
    _chr.Ship.Crew.Quantity = GetVariableCrew(_chr);
}

void SetCrewQuantityFull(ref _refCharacter)
{
	SetCrewQuantity(_refCharacter, GetMaxCrewQuantity(_refCharacter));
}

int SetCrewQuantityOverMax(ref _refCharacter, int num)
{
    if (num < 0) num = 0; // fix
    _refCharacter.Ship.Crew.Quantity = num;
	return true;
}
int AddCharacterCrew(ref _refCharacter,int num)
{
	return SetCrewQuantity(_refCharacter,GetCrewQuantity(_refCharacter)+num);
}
int RemoveCharacterCrew(ref _refCharacter,int num)
{
	int curCrew = GetCrewQuantity(_refCharacter);
	if(curCrew<num)
	{
		//Trace("Error!!! Remove overup crew (character=" + _refCharacter.index + ")");
		SetCrewQuantity(_refCharacter,0);
		return false;
	}
	SetCrewQuantityOverMax(_refCharacter,curCrew-num);//fix
	return true;
}
float GetSailPercent(ref _refCharacter)
{
	if( !CheckAttribute(_refCharacter,"Ship.SP") ) return 100.0;
	float fSP = GetCharacterShipSP(_refCharacter);
	if(fSP<=0.0) return 100.0;
	float fpsp = 100.0*stf(_refCharacter.Ship.SP)/fSP;
	return fpsp;
}
float GetHullPercent(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.HP")) return 100.0;
	int iHP = GetCharacterShipHP(_refCharacter);
	if(iHP<=0) return 100.0;
	float fphp = 100.0*stf(_refCharacter.Ship.HP)/iHP;
	return fphp;
}

float GetHullPercentWithModifier(ref _refCharacter, int iModifier)
{
	if(!CheckAttribute(_refCharacter,"Ship.HP")) return 100.0;
	int iHP = GetCharacterShipHP(_refCharacter);
	if(iHP<=0) return 100.0;
	float fphp = 100.0*(stf(_refCharacter.Ship.HP) + iModifier)/iHP;
	return fphp;
}

float GetSailRPD(ref _refCharacter)
{
	float repairSkill = GetSummonSkillFromNameToOld(_refCharacter, SKILL_REPAIR);
	if(CheckOfficersPerk(_refCharacter, "Carpenter"))
	{
		repairSkill = repairSkill * 1.1;
	}
	float damagePercent = 100.0 - GetSailPercent(_refCharacter);
	if (damagePercent == 0.0) return 0.0;

	float ret = repairSkill*15.0 / damagePercent;
	if (ret > damagePercent) ret = damagePercent;
	return ret;
}
float GetHullRPD(ref _refCharacter)
{
	float repairSkill = GetSummonSkillFromNameToOld(_refCharacter, SKILL_REPAIR);
	if(CheckOfficersPerk(_refCharacter, "Carpenter"))
	{
		repairSkill = repairSkill * 1.1;
	}
	float damagePercent = 100.0 - GetHullPercent(_refCharacter);
	if(damagePercent == 0.0) return 0.0;

	float ret = repairSkill*15.0 / damagePercent;
	if (ret > damagePercent) ret = damagePercent;
	return ret;
}
float GetSailSPP(ref _refCharacter)
{
	float ret = SHIP_CLASS_8-GetCharacterShipClass(_refCharacter);

	if (CheckOfficersPerk(_refCharacter, "Builder"))
	{
		ret = ret * 0.9;
	}
	return ret;
}
float GetHullPPP(ref _refCharacter)
{
	float ret = SHIP_CLASS_8-GetCharacterShipClass(_refCharacter);

	float HPpercent = GetCharacterShipHP(_refCharacter) / 700.0;

	if (HPpercent > ret) ret = HPpercent;

	if (CheckOfficersPerk(_refCharacter, "Builder"))
	{
		ret = ret * 0.9;
	}
	return ret;
}

float GetHullRepairDay(ref _refCharacter, bool _qty)
{
    float repPercent = 0.0;
    float matQ, tmpf;

    matQ = 0.0;
	if (GetHullPercent(_refCharacter)<100.0 )
	{
		repPercent = GetHullRPD(_refCharacter);
		matQ = repPercent*GetHullPPP(_refCharacter);
		tmpf = GetRepairGoods(true,_refCharacter);
		if (tmpf >= 0.0)
		{
			if (tmpf < matQ)
			{
                matQ = tmpf;
				repPercent = tmpf/GetHullPPP(_refCharacter);
			}
        }
	}
	if (_qty)
	{
	    return matQ;
	}
	return repPercent;
}

float GetSailRepairDay(ref _refCharacter, bool _qty)
{
    float repPercent = 0.0;
    float matQ, tmpf;

    matQ = 0.0;

	if (GetSailPercent(_refCharacter)<100.0 )
	{
		repPercent = GetSailRPD(_refCharacter);
		matQ = repPercent*GetSailSPP(_refCharacter);
		tmpf = GetRepairGoods(false,_refCharacter);
		if (tmpf >= 0.0)
		{
			if (tmpf < matQ)
			{
                matQ = tmpf;
				repPercent = tmpf/GetSailSPP(_refCharacter);
			}
        }
	}
	if (_qty)
	{
	    return matQ;
	}
	return repPercent;
}
// Fellowtravels utilites
int GetPassengersQuantity(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers.Quantity")) return 0;
	return sti(_refCharacter.Fellows.Passengers.Quantity);
}

int GetOfficerPassengerQuantity(ref _refCharacter)
{
	int psgQuant = GetPassengersQuantity(_refCharacter);
	int curIdx=0;
	ref curChar;
	int cn;
	int how = 0;
	bool ok;

	for (int i=0; i<psgQuant; i++)
	{
		cn = GetPassenger(_refCharacter,i);
		if(cn==-1) break;

		curChar = GetCharacter(cn);
		ok = CheckAttribute(curChar, "prisoned") && curChar.prisoned == true;
		if (!ok && GetRemovable(curChar))
		{
   			how++;
		}
	}
	return how;
}

int GetNotCaptivePassengersQuantity(ref _refCharacter)
{
	int result, idx;
	result = 0;
	idx = 0;
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers.Quantity")) return 0;
	for (int i=0; i <sti(_refCharacter.Fellows.Passengers.Quantity); i++)
	{
		if(sti(characters[idx].prisoned) != 1)
		{
			result = result+1;
			//idx = GetNotCaptivePassenger( _refCharacter,i);
			//if (idx >0) result = result+1;
		}
	}
	return result;
}

int GetFreePassengersQuantity(ref _refCharacter)
{
	int result, idx;
	result = 0;
	idx = 0;
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers.Quantity")) return 0;
	for (int i=0; i <sti(_refCharacter.Fellows.Passengers.Quantity); i++)
	{
		idx = GetPassenger( _refCharacter,i);
		if(!CheckAttribute(&characters[idx], "isfree"))
		{
			result = result+1;
		}
		//idx = GetFreePassenger( _refCharacter,i);
		//if (idx >0) result = result+1;
	}
	return result;
}

int GetNotQuestPassengersQuantity(ref _refCharacter)
{
	int result, idx;
	bool bOk;

	result = 0;
	idx = 0;
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers.Quantity")) return 0;
	for (int i=0; i <sti(_refCharacter.Fellows.Passengers.Quantity); i++)
	{
		idx = GetPassenger( _refCharacter,i);

		bOk =  CheckAttribute(&characters[idx], "prisoned") && sti(characters[idx].prisoned) == true;
		if (!bOk && !CheckAttribute(&characters[idx], "isquest"))
		{
			result = result+1;
		}
		/*idx = GetNotCaptivePassenger( _refCharacter,i);
		if (idx >0)
		{
			idx = GetNotQuestPassenger( _refCharacter,i);
		}
		if (idx >0) result = result+1;
		*/
	}
	return result;
}

int GetNotQuestFreePassengersQuantity(ref _refCharacter)
{
	int result, idx;
	result = 0;
	idx = 0;
	bool ok;
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers.Quantity")) return 0;
	for (int i=0; i <sti(_refCharacter.Fellows.Passengers.Quantity); i++)
	{
		idx = GetPassenger( _refCharacter,i);
		if (idx >0)
		{
			ok = !CheckAttribute(&characters[idx], "prisoned") || sti(characters[idx].prisoned) != true;
			if (ok && !CheckAttribute(&characters[idx], "isquest") && !CheckAttribute(&characters[idx], "isfree"))   //to_do  isquest?
			{
				result = result+1;
			}
		}
	}
	return result;
}

int GetPassenger(ref _refCharacter,int idx)
{
	if(idx<0) return -1;
	if(idx>=GetPassengersQuantity(_refCharacter)) return -1;

	string PsgAttrName = "id"+(idx+1);
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers."+PsgAttrName)) return -1;
	return sti(_refCharacter.Fellows.Passengers.(PsgAttrName));
}

int GetPassengerEx(ref _refCharacter,int idx)
{
	if(idx < 0)
	{
		return -1;
	}
	if(idx > GetPassengersQuantity(_refCharacter))
	{
		return -1;
	}
	if(idx == 0)
	{
		return nMainCharacterIndex;
	}
	string PsgAttrName = "id" + (idx);
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers."+PsgAttrName))
	{
		return -1;
	}
	return sti(_refCharacter.Fellows.Passengers.(PsgAttrName));
}

int GetPassengerNumber(ref _refCharacter,int findCharacterIdx)
{
	int psgQuant = GetPassengersQuantity(_refCharacter);
	int cn;
	ref cr;
	for(int i=0; i<psgQuant; i++)
	{
		cn = GetPassenger(_refCharacter,i);
		if(cn==-1) break;
		cr = GetCharacter(cn);
		if(findCharacterIdx==sti(cr.index)) return i;
	}
	return -1;
}
int GetNotCaptivePassenger(ref _refCharacter,int idx)
{
	if(idx<0) return -1;
	int psgQuant = GetPassengersQuantity(_refCharacter);

	int curIdx=0;
	ref curChar;
	int cn;
	for(int i=0;i<psgQuant;i++)
	{
		cn = GetPassenger(_refCharacter,i);
		if(cn==-1) break;

		curChar = GetCharacter(cn);
		if(CheckAttribute(curChar,"prisoned"))
		{
			if(sti(curChar.prisoned)==true) continue;
		}
		if(curIdx==idx)	return sti(curChar.index);
		curIdx++;
	}
	return -1;
}

int GetFreePassenger(ref _refCharacter,int idx)
{
	if(idx<0) return -1;
	int psgQuant = GetPassengersQuantity(_refCharacter);

	int curIdx=0;
	ref curChar;
	int cn;
	for(int i=0;i<psgQuant;i++)
	{
		cn = GetPassenger(_refCharacter,i);
		if(cn==-1) break;

		curChar = GetCharacter(cn);
		if(CheckAttribute(curChar,"isfree"))
		{
			continue;
		}
		if(curIdx==idx)	return sti(curChar.index);
		curIdx++;
	}
	return -1;
}

int GetNotQuestPassenger(ref _refCharacter,int idx)
{
	if(idx<0) return -1;
	int psgQuant = GetPassengersQuantity(_refCharacter);

	int curIdx=0;
	ref curChar;
	int cn;
	for(int i=0;i<psgQuant;i++)
	{
		cn = GetPassenger(_refCharacter,i);
		if(cn==-1) break;

		curChar = GetCharacter(cn);
		if(CheckAttribute(curChar,"isquest") || CheckAttribute(curChar,"isfree"))
		{
			continue;
		}
		if(curIdx==idx)	return sti(curChar.index);
		curIdx++;
	}
	return -1;
}

int ChangePassenger(ref _refCharacter,int idx, int psngIdx)
{
	int retVal = GetPassenger(_refCharacter,idx);
	if(idx>=0)
	{
		string PsgAttrName = "id"+(idx+1);
		_refCharacter.Fellows.Passengers.(PsgAttrName) = psngIdx;
	}
	return retVal;
}
int AddPassenger(ref _refCharacter,ref _refPassenger, int prisonFlag)
{
	int PsgQuantity = GetPassengersQuantity(_refCharacter);
	if(PsgQuantity<PASSENGERS_MAX)
	{
		aref tmpRef; makearef(tmpRef,_refCharacter.Fellows.Passengers);
		string PsgAttrName;
		for(int i=0;i<PsgQuantity;i++)
		{
			PsgAttrName = "id"+(i+1);
			if(tmpRef.(PsgAttrName)==_refPassenger.index) return PsgQuantity;
		}
		PsgQuantity++;
		tmpRef.Quantity = PsgQuantity;
		PsgAttrName = "id"+PsgQuantity;
		tmpRef.(PsgAttrName) = _refPassenger.index;
		if(prisonFlag==true)	_refPassenger.prisoned = true;
	}
	else	trace("Overup maximum passengers quantity");
	return PsgQuantity;
}
int RemovePassenger(ref _refCharacter,ref _refPassenger)
{
 	if (sti(_refCharacter.index) == GetMainCharacterIndex())
	{
		CheckForReleaseOfficer(sti(_refPassenger.index));  // super fix
	}
	else
	{
	    RemoveOfficersIndex(_refCharacter,sti(_refPassenger.index));
	}
	int PsgQuantity = GetPassengersQuantity(_refCharacter);
	int psgNum = GetPassengerNumber(_refCharacter,sti(_refPassenger.index));
	if(psgNum==-1) return PsgQuantity;

	aref tmpRef;
	makearef(tmpRef,_refCharacter.Fellows.Passengers);
	string inPsgAttrName,outPsgAttrName;
	for(int i=(psgNum+1); i<PsgQuantity; i++)
	{
		inPsgAttrName = "id"+i;
		outPsgAttrName = "id"+(i+1);
		tmpRef.(inPsgAttrName) = tmpRef.(outPsgAttrName);
	}
	outPsgAttrName = "id"+PsgQuantity;
	DeleteAttribute(tmpRef,outPsgAttrName);
	PsgQuantity--;
	tmpRef.Quantity = PsgQuantity;
	return PsgQuantity;
}

int FindFellowtravellers(ref _refCharacter,ref _refFindCharacter)
{
	int i;
	string stmp;
	aref atmp;
	aref curref;

	if(sti(_refFindCharacter.index)==-1) return FELLOWTRAVEL_NO;
	if(CheckAttribute(_refFindCharacter,"prisoned"))
	{
		if(sti(_refFindCharacter.prisoned)==true) return FELLOWTRAVEL_CAPTIVE;
	}
	//#20170318-20
	for(i=1;i<=MAX_NUM_FIGHTERS;i++)
	{
		if( sti(_refFindCharacter.index) == GetOfficersIndex(_refCharacter,i) )	return FELLOWTRAVEL_OFFICER;
	}
	for(i=0;i<GetPassengersQuantity(_refCharacter);i++)
	{
		if(sti(_refFindCharacter.index)==GetPassenger(_refCharacter,i))	return FELLOWTRAVEL_PASSENGER;
	}
	for(i=1;i<COMPANION_MAX;i++)
	{
		if( GetCompanionIndex(_refCharacter,i)==sti(_refFindCharacter.index) )
		{
			return FELLOWTRAVEL_COMPANION;
		}
	}
	return FELLOWTRAVEL_NO;
}

bool CheckPassengerInCharacter(ref _refBaseChar, string _seekId)
{
	int psgQuant = GetPassengersQuantity(_refBaseChar);
    if(psgQuant<0) return false;
	int cn;
	for(int i=0;i<psgQuant;i++)
	{
		cn = GetPassenger(_refBaseChar,i);
		if(cn==-1) continue;
		if (characters[cn].id == _seekId) return true;
	}
	return false;
}

int SetCompanionIndex(ref _refCharacter,int _CompanionNum, int _CompanionIdx)
{
  if(_CompanionNum == -1)
	{
		for(int i = 1; i < COMPANION_MAX; i++)
		{
			if (GetCompanionIndex(_refCharacter, i) == -1)
			{
				_CompanionNum = i;
				break;
			}
		}
	}
	if(_CompanionNum < 1) return _CompanionIdx;
	if(_CompanionNum > COMPANION_MAX - 1) return _CompanionIdx;

	if(_CompanionIdx!=-1)
	{
		for(i=0;i<COMPANION_MAX;i++)
		{
			if(GetCompanionIndex(_refCharacter,i)==_CompanionIdx) return -1;
		}
	}
	string compName = "id"+_CompanionNum;
	int retVal = GetCompanionIndex(_refCharacter,_CompanionNum);
	_refCharacter.Fellows.Companions.(compName) = _CompanionIdx;

	//Character_SetCompanionEnemyEnable(&characters[_CompanionIdx], true);

	if( _CompanionIdx>=0 && CheckAttribute(&Characters[_CompanionIdx],"nation") ) {
		Characters[_CompanionIdx].prev_nation = Characters[_CompanionIdx].nation;
		Characters[_CompanionIdx].nation = _refCharacter.nation;
		Characters[_CompanionIdx].location = "none";//fix
	}
	if( retVal>=0 && CheckAttribute(&Characters[retVal],"prev_nation") ) {
		Characters[retVal].nation = Characters[retVal].prev_nation;
		Characters[retVal].location = "none"; //fix
	}
	// to_do CheckCompanionSkillsUp(_CompanionIdx);
	Event(EVENT_CHANGE_COMPANIONS,"");
	return _CompanionIdx;
}
int RemoveCharacterCompanion(ref _refCharacter, ref refCompanion)
{
	string compName;
	int i;

	aref refComps;
	makearef(refComps,_refCharacter.Fellows.Companions);
	for(i=1; i<COMPANION_MAX; i++)
	{
		compName = "id"+i;
		if(CheckAttribute(refComps,compName) && refComps.(compName)==refCompanion.index)
		{
			refComps.(compName) = -1;
			refCompanion.location = "none";
			refCompanion.location.group = _refCharacter.location.group;
			refCompanion.location.locator = _refCharacter.location.locator;
			Event(EVENT_CHANGE_COMPANIONS,"");

			return i;
		}
	}
	return -1;
}
int GetCompanionIndex(ref _refCharacter,int _CompanionNum)
{
	if(_CompanionNum < 0)
	{
		return -1;
	}
	if(_CompanionNum > (COMPANION_MAX - 1))
	{
		return -1;
	}
	if(_CompanionNum==0)
	{
		if (!CheckAttribute(_refCharacter,"index"))
		{
			//Log_Info("Error GetCompanionIndex");
			return -1;
		}
		return sti(_refCharacter.index);
	}
	string compName = "id"+_CompanionNum;
	if(!CheckAttribute(_refCharacter, "Fellows.Companions."+compName))
	{
		return -1;
	}
	if(sti(_refCharacter.Fellows.Companions.(compName)) < 1)
	{
		return -1;
	}
	if(sti(characters[sti(_refCharacter.Fellows.Companions.(compName))].ship.type) != SHIP_NOTUSED)
	{
		return sti(_refCharacter.Fellows.Companions.(compName));
	}
	return -1;
}
int GetCompanionNumber(ref _refCharacter,int _CompanionIdx)
{
	for(int i=0; i<COMPANION_MAX; i++)
	{
		if( GetCompanionIndex(_refCharacter,i) == _CompanionIdx ) return i;
	}
	return -1;
}
int GetCompanionQuantity(ref _refCharacter)
{
	int qn = 0;
	for(int i=0; i<COMPANION_MAX; i++)
	{
		if( GetCompanionIndex(_refCharacter,i)>=0 ) qn++;
	}
	return qn;
}

int GetRemovableCompanionsNumber(ref _refCharacter)
{
	int qn = 0;
	int cn = 1;
	for(int i=0; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if(cn > 0 && GetShipRemovable(&characters[cn]) == true)
		{
			qn++;
		}
	}
	return qn;
}

bool CheckCompanionInCharacter(ref _refBaseChar, string _seekId)
{
	int cn;
	for(int i=0;i<COMPANION_MAX;i++)
	{
		cn = GetCompanionIndex(_refBaseChar,i);
		if(cn==-1) continue;
		if (characters[cn].id == _seekId) return true;
	}
	return false;
}

int GetOfficersQuantity(ref _refCharacter)
{
	int idx=0;
	//#20170318-20
	for(int i=1; i<=MAX_NUM_FIGHTERS; i++)
	{
		if( GetOfficersIndex(_refCharacter,i)!=-1 ) idx++;
	}
	return idx;
}
int GetOfficersIndex(ref _refCharacter,int _OfficerNum)
{
	if(_OfficerNum<0) return -1;
	//#20170318-20
	if(_OfficerNum>MAX_NUM_FIGHTERS) return -1;
	if(_OfficerNum==0)
    {
        if(!CheckAttribute(_refCharacter,"index")) return -1; // fix
        return MakeInt(_refCharacter.index);
    }
	string compName = "id"+_OfficerNum;
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers.Officers."+compName)) return -1;
	if(sti(_refCharacter.Fellows.Passengers.Officers.(compName)) < 1)
	{
		return - 1;
	}
	return sti(_refCharacter.Fellows.Passengers.Officers.(compName));
}

int SetOfficersIndex(ref _refCharacter,int _OfficerNum, int _OfficerIdx)
{
	int i;
    if(_OfficerNum == -1)
	{
	    //#20170318-20
		for(i=1; i<=MAX_NUM_FIGHTERS; i++)
		{
			if(GetOfficersIndex(_refCharacter, i) == -1)
			{
				_OfficerNum = i;
				break;
			}
		}
        // fix
        if (_OfficerNum == -1)
        {
            //#20170318-20
            _OfficerNum = MAX_NUM_FIGHTERS;
        }
	}
	if(_OfficerNum<1) return _OfficerIdx;
	//#20170318-20
	if(_OfficerNum>MAX_NUM_FIGHTERS) return _OfficerIdx;

	if(_OfficerIdx!=-1)
	{
	    //#20170318-20
		for(i=1;i<=MAX_NUM_FIGHTERS;i++)
		{
			if(GetOfficersIndex(_refCharacter,i)==_OfficerIdx) return -1;
		}
		AddPassenger(_refCharacter,GetCharacter(_OfficerIdx),false);
	}
	string compName = "id"+_OfficerNum;
	int retVal = GetOfficersIndex(_refCharacter,_OfficerNum);
	_refCharacter.Fellows.Passengers.Officers.(compName) = _OfficerIdx;
	if(_OfficerIdx>=0)
	{
		LAi_SetOfficerType(GetCharacter(_OfficerIdx));
		Characters[_OfficerIdx].location = _refCharacter.location;
	}
	if(retVal>=0)
	{
		LAi_SetCitizenTypeNoGroup(GetCharacter(retVal));
		Characters[retVal].location = "none";
	}
	Event(EVENT_CHANGE_OFFICERS,"");

	return retVal;
}
bool RemoveOfficersIndex(ref _refCharacter, int _OfficerIdx)
{
	if(_OfficerIdx==-1) return false;
	//#20170318-20
	for(int i=1; i<=MAX_NUM_FIGHTERS; i++)
	{
		if(GetOfficersIndex(_refCharacter,i) == _OfficerIdx)
		{
			SetOfficersIndex(_refCharacter,i,-1);
			return true;
		}
	}
	return false;
}

int AddMoneyToCharacter(ref _refCharacter,int _Money)
{

	if (_Money < 0 && sti(_refCharacter.Money) < abs(_Money))
	{
	    _Money = -sti(_refCharacter.Money);
	}
	int newMoney = sti(_refCharacter.Money) + _Money;
	if(newMoney<0) newMoney=0;
	_refCharacter.Money = newMoney;

	if (sti(_refCharacter.index) == GetMainCharacterIndex())
	{
		if (_Money > 0)
		{
			Log_Info(xiStr("MSG_RPG_4") + _Money + xiStr("MSG_RPG_5"));
		}
		else
		{
		    if (_Money < 0)
			{
				Log_Info(xiStr("MSG_RPG_6") + abs(_Money) + xiStr("MSG_RPG_5"));
			}
		}
	}
	return newMoney;
}

void SetBaseShipData(ref refCharacter)
{
    int  i;
    aref refShip;
    int  nShipType;
    ref  refBaseShip;

	if (CheckAttribute(refCharacter,"Ship"))
	{
		if(!CheckAttribute(refCharacter, "ship.upgrades"))
		{
			refCharacter.ship.upgrades.hull = 1;
			refCharacter.ship.upgrades.sails = 1;
			refCharacter.ship.upgrades.cannons = 1;
		}
		makearef(refShip,refCharacter.Ship);
		nShipType = GetCharacterShipType(refCharacter);
		if(nShipType==SHIP_NOTUSED) return;

		//trace (refCharacter.id);
		refBaseShip = GetRealShip(nShipType);

		//Boyer add trace if no good...
		if(!CheckAttribute(refBaseShip, "class")) {
			Trace("No good ship class fromSetBaseShipData, nShipType = " + nShipType +
			      " refCharacter.id = " + refCharacter.id);
		}
		if(!CheckAttribute(refBaseShip, "HP"))
		{
			trace ("ship have not HP.");
			return;
		}
		refShip.HP = refBaseShip.HP;
		refShip.SP = refBaseShip.SP;

		refShip.Pos.x = 0;
		refShip.Pos.y = 0;
		refShip.Pos.z = 0;
		refShip.Ang = "";
		refShip.Cannons.Borts = "";
		if (CheckAttribute(refShip, "Cannons.Borts.cannonf.damages")) { DeleteAttribute(refShip, "Cannons.Borts.cannonf.damages"); }
		if (CheckAttribute(refShip, "Cannons.Borts.cannonb.damages")) { DeleteAttribute(refShip, "Cannons.Borts.cannonb.damages"); }
		if (CheckAttribute(refShip, "Cannons.Borts.cannonl.damages")) { DeleteAttribute(refShip, "Cannons.Borts.cannonl.damages"); }
		if (CheckAttribute(refShip, "Cannons.Borts.cannonr.damages")) { DeleteAttribute(refShip, "Cannons.Borts.cannonr.damages"); }

		refShip.Cannons.Charge.Type = GOOD_BALLS;

		if (!CheckAttribute(refShip,"Cannons.Type"))
		{
			refShip.Cannons.Type = MakeInt(refBaseShip.Cannon);
		}
		if (!CheckAttribute(refShip,"Crew.Morale"))
		{
			refShip.Crew.Morale = 20 + rand(79);
		}
		if (!CheckAttribute(refShip,"Crew.Quantity"))
		{
			//refShip.Crew.Quantity = refBaseShip.OptCrew;
			refShip.Crew.Quantity = GetVariableCrew(refCharacter);
		}
		SetGoodsInitNull(refCharacter);
        if(!CheckAttribute(refCharacter, "ship.crew.Exp"))
		{
			refCharacter.Ship.Crew.Exp.Sailors   = 1 + rand(80);
			refCharacter.Ship.Crew.Exp.Cannoners = 1 + rand(80);
			refCharacter.Ship.Crew.Exp.Soldiers  = 1 + rand(80);
		}
		int iGoodN = 0;
		int iGoodR = 0;

		i = GetCharacterFreeSpace(refCharacter,GOOD_POWDER) / 40;
        if(i>0)
        {
			if(i>=500)
            {
				SetCharacterGoods(refCharacter,GOOD_POWDER, 500 - rand(50));
			} else
            {
				SetCharacterGoods(refCharacter,GOOD_POWDER,i);
			}
		}
		// bombs
		i = GetCharacterFreeSpace(refCharacter,GOOD_BOMBS) / 42;
		if(i>0)
		{
			if(i > 600)
			{
				i = 600;
			}
			iGoodN = 20;
			iGoodR = rand(i - iGoodN);
			if(iGoodR < 0)
			{
				iGoodR = 0;
			}
			iGoodN = iGoodN + iGoodR;
			SetCharacterGoods(refCharacter,GOOD_BOMBS,iGoodN);
		}
		// grapes
		i = GetCharacterFreeSpace(refCharacter,GOOD_GRAPES) / 60;
		if(i>0)
		{
			if(i > 200)
			{
				i = 200;
			}
			iGoodN = 20;
			iGoodR = rand(i - iGoodN);
			if(iGoodR < 0)
			{
				iGoodR = 0;
			}
			iGoodN = iGoodN + iGoodR;
			SetCharacterGoods(refCharacter,GOOD_GRAPES,iGoodN);
		}
		// knippels
		i = GetCharacterFreeSpace(refCharacter,GOOD_KNIPPELS) / 60;
		if(i>0)
		{
			if(i > 200)
			{
				i = 200;
			}
			iGoodN = 20;
			iGoodR = rand(i - iGoodN);
			if(iGoodR < 0)
			{
				iGoodR = 0;
			}
			iGoodN = iGoodN + iGoodR;
			SetCharacterGoods(refCharacter,GOOD_KNIPPELS,iGoodN);
		}
		// cannonballs
		i = GetCharacterFreeSpace(refCharacter,GOOD_BALLS) / 42;
		if(i>0)
		{
			if(i > 800)
			{
				i = 800;
			}
			iGoodN = 20;
			iGoodR = rand(i - iGoodN);
			if(iGoodR < 0)
			{
				iGoodR = 0;
			}
			iGoodN = iGoodN + iGoodR;
			SetCharacterGoods(refCharacter,GOOD_BALLS,iGoodN);
		}
		//food
		i = GetCharacterFreeSpace(refCharacter,GOOD_FOOD) / 20;
		if(i>0)
		{
            if(i > 300)
			{
				i = 300;
			}
			iGoodN = 5;
			iGoodR = rand(i - iGoodN);
			if(iGoodR < 0)
			{
				iGoodR = 0;
			}
			iGoodN = iGoodN + iGoodR;
			SetCharacterGoods(refCharacter,GOOD_FOOD,iGoodN);
		}
		//GOOD_WEAPON
		i = GetCharacterFreeSpace(refCharacter,GOOD_WEAPON) / 60;
		if(i>0)
		{
            if(i > 300)
			{
				i = 300;
			}
			iGoodN = 5;
			iGoodR = rand(i - iGoodN);
			if(iGoodR < 0)
			{
				iGoodR = 0;
			}
			iGoodN = iGoodN + iGoodR;
			SetCharacterGoods(refCharacter,GOOD_WEAPON,iGoodN);
		}

		i = GetCharacterFreeSpace(refCharacter,GOOD_MEDICAMENT) / 100;
		if(i>0)
		{
            if(i > 300)
			{
				i = 300;
			}
			iGoodN = 5;
			iGoodR = rand(i - iGoodN);
			if(iGoodR < 0)
			{
				iGoodR = 0;
			}
			iGoodN = iGoodN + iGoodR;
			SetCharacterGoods(refCharacter,GOOD_MEDICAMENT,iGoodN);
		}
	}
	refCharacter.ship.crew.disease = 0;
}
void SetGoodsInitNull(ref refCharacter)
{
    string goodsName;
    int i;

	refCharacter.Ship.Cargo.Load = 0;
	for (i=0; i<GOODS_QUANTITY; i++)
	{
		goodsName = Goods[i].Name;
		refCharacter.Ship.Cargo.Goods.(goodsName) = 0;
	}
}

void SetBaseFellows(object refCharacter)
{
	int i;
	string sAttName;
	aref tmpRef;

	makearef(tmpRef,refCharacter.Fellows.Companions);
	//Boyer mod #20170318-55
	for(i=1;i<=COMPANION_MAX;i++) {
		sAttName = "id" + i;
		tmpRef.(sAttName) = -1;
	}
	makearef(tmpRef,refCharacter.Fellows.Passengers);
	tmpRef.Quantity = 0;
	tmpRef.id1 = -1;
	tmpRef.id2 = -1;
	tmpRef.id3 = -1;
	tmpRef.id4 = -1;
	tmpRef.id5 = -1;
	tmpRef.id6 = -1;
	tmpRef.id7 = -1;
	tmpRef.id8 = -1;

	makearef(tmpRef,refCharacter.Fellows.Passengers.Officers);
	//Boyer mod #20170318-20
	for(i=1;i<=MAX_NUM_FIGHTERS;i++) {
		sAttName = "id" + i;
		tmpRef.(sAttName) = -1;
	}
}

// Items Utilite
int GetChrItemQuantity(ref _refCharacter)
{
	aref ar; makearef(ar,_refCharacter.items);
	return GetAttributesNum(ar);
}
bool GiveItem2Character(ref _refCharacter,string itemName)
{
	return TakeNItems(_refCharacter,itemName,1);
}
void TakeItemFromCharacter(ref _refCharacter,string itemName)
{
	TakeNItems(_refCharacter,itemName,-1);
}
bool CheckCharacterItem(ref _refCharacter,string itemName)
{
	if( CheckAttribute(_refCharacter,"Items."+itemName) && sti(_refCharacter.Items.(itemName))>0 )	return true;
	else	return false;
}
int GetCharacterItem(ref _refCharacter,string itemName)
{
	if(CheckAttribute(_refCharacter,"Items."+itemName))
	{
		return sti(_refCharacter.Items.(itemName));
	}
	return 0;
}

int GetCharacterFreeItem(ref _refCharacter,string itemName)
{
	if(CheckAttribute(_refCharacter,"Items."+itemName))
	{
		int iItemQ = sti(_refCharacter.Items.(itemName));
		if(IsEquipCharacterByItem(_refCharacter, itemName))
		{
			iItemQ = iItemQ - 1;
		}
		return iItemQ;
	}
	return 0;
}

bool ReplaceItem(ref _refTakingCharacter,ref _refGivingCharacter,string itemName)
{
	bool retVal = CheckCharacterItem(_refGivingCharacter,itemName);
	if( TakeNItems(_refTakingCharacter,itemName,1) )
		TakeNItems(_refGivingCharacter,itemName,-1);
	return retVal;
}
bool TakeNItems(ref _refCharacter,string itemName, int n)
{
	int q;
	aref arItm;
	if( Items_FindItem(itemName,&arItm)<0 )
	{
		//trace("WARNING!!! Item id = "+itemName+" not implemented");
		return false;
	}
	if( CheckAttribute(arItm,"gold") )
	{
		if( CheckAttribute(_refCharacter,"Money") )	q = sti(_refCharacter.Money);
		else q = 0;
		q += n*sti(arItm.gold);
		if(q<0) {q=0;}
		_refCharacter.Money = q;
		return true;
	}
	if (n>0 && findsubstr(itemName, "Totem_" , 0) != -1 && GetCharacterItem(_refCharacter,itemName) > 0 && !CheckAttribute(arItm, "shown.used"))
	{
		return true;
	}
	if( CheckAttribute(arItm,"price") && sti(arItm.price)==0 )
	{
		if(sti(_refCharacter.index)==GetMainCharacterIndex() && IsEntity(_refCharacter))
		{
			if(n>0)	{Log_SetStringToLog(XI_ConvertString("You take item"));}
			if(n<0)	{Log_SetStringToLog(XI_ConvertString("You give item"));}
			PlayStereoSound("interface\important_item.wav");
		}
		if( n>0 && IsOfficer(_refCharacter) || IsCompanion(_refCharacter) ) {
			AddMsgToCharacter(_refCharacter,MSGICON_GETITEM);
		}
	}
	q = GetCharacterItem(_refCharacter,itemName);
	if(q+n<=0) DeleteAttribute(_refCharacter,"Items."+itemName);
	else
	{
		if(q<=0 && GetChrItemQuantity(_refCharacter)>=MAX_ITEM_TAKE) return false;
		_refCharacter.Items.(itemName) = q+n;
	}
	return true;
}

int GetCharacterCurrentIsland(ref _refCharacter)
{
	int curLocNum = FindLocation(_refCharacter.location);   // fix Characters[GetMainCharacterIndex()]
	if(curLocNum<0) return -1;
	return GetIslandIdxByLocationIdx(curLocNum);
}

int GetIslandIdxByLocationIdx(int locIdx)
{
	aref rootar,ar;
	makearef(rootar,Locations[0].IslandsList);
	for(int i=0; i<GetAttributesNum(rootar); i++)
	{
		ar = GetAttributeN(rootar,i);
		if (locIdx >= sti(ar.begin) && locIdx < sti(ar.end) ) //fix 02.02.05
		{
			return FindIsland(GetAttributeName(ar));
		}
	}
	return -1;
}

int GetCurrentLocationNation()
{
	int curLocNum = FindLocation(Characters[GetMainCharacterIndex()].location);
	if(curLocNum<0) return -1;
	return GetLocationNation(&Locations[curLocNum]);
}

void SetRandomNameToCharacter(ref rCharacter)
{
	int iNation = sti(rCharacter.nation);
	//#2019011-04
	if (iNation < 0 || iNation >= MAX_NATIONS) iNation = PIRATE;
	while (iNation == PIRATE) { iNation = rand(MAX_NATIONS - 1); }

	ref rNames, rLastNames;

	switch(iNation)
	{
		case FRANCE:
			rNames = &sFrManNames;
			if (rCharacter.sex != "man" && rCharacter.sex != "skeleton") rNames = &sFrWomenNames;
			rLastNames = &sFrFamilies;
		break;
		case SPAIN:
			rNames = &sSpManNames;
			if (rCharacter.sex != "man" && rCharacter.sex != "skeleton") rNames = &sSpWomenNames;
			rLastNames = &sSpFamilies;
		break;
		case HOLLAND:
			rNames = &sHoManNames;
			if (rCharacter.sex != "man" && rCharacter.sex != "skeleton") rNames = &sHoWomenNames;
			rLastNames = &sHoFamilies;
		break;
		case PIRATE:
			rNames = &sEnManNames;
			if (rCharacter.sex != "man" && rCharacter.sex != "skeleton") rNames = &sEnWomenNames;
			rLastNames = &sEnFamilies;
		break;
		//#20180713-01 New Portugal nation
        case PORTUGAL:
            rNames = &sSpManNames;
			if (rCharacter.sex != "man" && rCharacter.sex != "skeleton") rNames = &sSpWomenNames;
			rLastNames = &sSpFamilies;
		break;
        //Default English
		rNames = &sEnManNames;
        if (rCharacter.sex != "man" && rCharacter.sex != "skeleton") rNames = &sEnWomenNames;
        rLastNames = &sEnFamilies;
	}
	int iMassiveOfNamesSize = GetArraySize(rNames);
    int nRand = rand(iMassiveOfNamesSize-1);
    if (nRand < 0)
        nRand = 0;
	rCharacter.name = GetRandSubString(rNames[nRand]);
	iMassiveOfNamesSize = GetArraySize(rLastNames);
    nRand = rand(iMassiveOfNamesSize-1);
    if (nRand < 0)
        nRand = 0;
	rCharacter.lastname = GetRandSubString(rLastNames[nRand]);
}

string GenerateRandomName(int iNation, string sSex)
{
	//#2019011-04
	if (iNation < 0 || iNation >= MAX_NATIONS) iNation = PIRATE;
	while (iNation == PIRATE) { iNation = rand(MAX_NATIONS - 1); }

	ref rNames, rLastNames;

	switch(iNation)
	{
		case FRANCE:
			rNames = &sFrManNames;
			if (sSex != "man") rNames = &sFrWomenNames;
			rLastNames = &sFrFamilies;
		break;
		case SPAIN:
			rNames = &sSpManNames;
			if (sSex != "man") rNames = &sSpWomenNames;
			rLastNames = &sSpFamilies;
		break;
		case HOLLAND:
			rNames = &sHoManNames;
			if (sSex != "man") rNames = &sHoWomenNames;
			rLastNames = &sHoFamilies;
		break;
		case PIRATE:
			rNames = &sEnManNames;
			if (sSex != "man") rNames = &sEnWomenNames;
			rLastNames = &sEnFamilies;
		break;
		//#20180713-01 New Portugal nation
        case PORTUGAL:
            rNames = &sSpManNames;
			if (sSex != "man") rNames = &sSpWomenNames;
			rLastNames = &sSpFamilies;
		break;
        //Default English
		rNames = &sEnManNames;
        if (sSex != "man") rNames = &sEnWomenNames;
        rLastNames = &sEnFamilies;
	}
	int iMassiveOfNamesSize = GetArraySize(rNames);
    int nRand = rand(iMassiveOfNamesSize-1);
    if (nRand < 0)
        nRand = 0;
	string sname = GetRandSubString(rNames[nRand]);
	iMassiveOfNamesSize = GetArraySize(rLastNames);
    nRand = rand(iMassiveOfNamesSize-1);
    if (nRand < 0)
        nRand = 0;
	string slastname = GetRandSubString(rLastNames[nRand]);

	sname = sname + " " + slastName;
	return sName;
}

//  EQUIP SECTION
string FindCharacterItemByGroup(ref chref, string groupID)
{
 	int i,n;
	ref refItm;
    float maxBladeValue = 0.0;
    float curBladeValue;
    //Boyer check Cuirass strength #20170318-54
    float maxCirassValue = 0.0;
    float curCirassValue;
    bool bCirassCheck = false;
    //Boyer check gun feasibility #20170318-54
    float maxGunValue = 0.0;
    float curGunValue;
    bool bShootist = false;
    bool bClever = false;
    bool bGunCheck, bShootistCheck;

    string resultItemId = "";
    bool bIsOff = false;
    if(IsOfficer(chref))
        bIsOff = true;
    if(!bIsOff && IsCompanion(chref))
        bIsOff = true;
    if (groupID == BLADE_ITEM_TYPE && bIsOff && IsEquipCharacterByItem(chref, "unarmed") && !CheckAttribute(chref, "isMusketer"))
	{
        RemoveCharacterEquip(chref, BLADE_ITEM_TYPE);
        TakeItemFromCharacter(chref, "unarmed");
	}
	//Boyer add #20170318-54
	bShootist = IsCharacterPerkOn(chref,"Gunman");
	bClever = IsCharacterPerkOn(chref,"GunProfessional");
	//#20200228-03
    bool bMuskSupport = false;
	string sAni = "";
	if(groupID==GUN_ITEM_TYPE) {
        if(CheckAttribute(chref, "model")) {
            string chrModel = chref.model;
            if(GetINIString("pscripts\MusketAni.ini", chrModel, &sAni))
            {
               bMuskSupport = true;
            }
            else {
                chrModel = chref.model + "_mush":
                if(GetINIString("pscripts\MusketAni.ini", chrModel, &sAni))
                    bMuskSupport = true;
            }
        }
	}
	for(i=ITEMS_QUANTITY-1; i>=0; i--)
	{
		refItm = &Items[i];
		if( !CheckAttribute(refItm,"groupID") ) continue;
		if(refItm.groupID!=groupID) continue;
		if( !CheckAttribute(chref,"items."+refItm.id) ) continue;
		if(groupID==GUN_ITEM_TYPE)
		{
		    //Skip muskets
		    //#20190114-01
		    //if(refItm.id == "mushket" || refItm.id == "mushket1" || refItm.id == "mushket2x2") continue;
		    //#20200228-03
		    bool bIsMusket = CheckAttribute(refItm, "isMusket");
		    if(bIsMusket && !bMuskSupport) continue;
			if( !CheckAttribute(refItm,"chargeQ")) continue;
			n = sti(refItm.chargeQ);
			//Boyer remove for changing the gun decision logic to account for reload time, # charges, min/max, accuracy
			//#20170318-54
			/*
			if(n<2) {return refItm.id;}
			if(n<4)
			{
				if( IsCharacterPerkOn(chref,"Gunman") ) {return refItm.id;}
				else continue;
			}

            		if( IsCharacterPerkOn(chref,"GunProfessional") )	{return refItm.id;}

			continue; */
			//Boyer removed above and new gun selection changes below #20170318-54
			curGunValue = sti(refItm.chargeQ) * GUN_SPEED_BASE / sti(refItm.chargespeed)
					* sti(refItm.accuracy) / 100.0
					* (stf(refItm.dmg_min) * GUN_MIN_WT + (stf(refItm.dmg_max) * GUN_MAX_WT - stf(refItm.dmg_min) * GUN_MIN_WT) / 2);
			bShootistCheck = n < 4 && bShootist;
            bGunCheck = n < 2 || bShootistCheck || bClever;
			if (bGunCheck && curGunValue > maxGunValue)
			{
			    if(bIsMusket && rand(3)!= 1) continue; //25% chance to use musket if avail
                maxGunValue = curGunValue;
                resultItemId  = refItm.id;
			}
			continue;
		}
		//#20171102-01 Add hat/helmet
        if (groupID == HEAD_ITEM_TYPE)
		{
		    curCirassValue = stf(refItm.CirassLevel);
            if (curCirassValue > maxCirassValue)
            {
                maxCirassValue = curCirassValue;
                resultItemId  = refItm.id;
            }
            continue;
		}
		if (groupID == CIRASS_ITEM_TYPE)
		{
		    //#20171102-01 Add hat/helmet
	   		//Boyer change for girdles, boots, gloves not needing perk...also use best one based on highest .CirassLevel
           	//#20170318-56
           		//if( IsCharacterPerkOn(chref, "Ciras") )	{return refItm.id;}
            //#20190113-03
	   		bCirassCheck = CheckAttribute(refItm, "skipPerkCheck");
	   		if( IsCharacterPerkOn(chref, "Ciras") || bCirassCheck )	{
				//return refItm.id;
				curCirassValue = stf(refItm.CirassLevel);
				if (curCirassValue > maxCirassValue)
				{
                    maxCirassValue = curCirassValue;
                    resultItemId  = refItm.id;
				}
			}
			continue;
		}
		//#20190729-01
		if (groupID == BLADE_ITEM_TYPE && !CheckAttribute(chref, "isMusketer"))
		{
			curBladeValue = (stf(refItm.dmg_min)*3 + (stf(refItm.dmg_max)*GetCharacterSkill(chref, refItm.FencingType)) / SKILL_MAX) / GetEnergyBladeDrain(stf(refItm.Weight));// + stf(refItm.piercing) + stf(refItm.block);
			if (curBladeValue > maxBladeValue)
			{
			    maxBladeValue = curBladeValue;
			    resultItemId  = refItm.id;
			}
		}
		//else
		//{
		    //Boyer change...might have been CIRASS_ITEM_TYPE or GUN_ITEM_TYPE still being determined
		    //#20170318-54 and #20170318-56
		    //return refItm.id;
		    //if (resultItemId == "") return refItm.id;
		//}
	}
	if (resultItemId != "")
	{
        return resultItemId;
	}
	if (groupID == BLADE_ITEM_TYPE && bIsOff && sti(chref.index) != GetMainCharacterIndex() && !CheckAttribute(chref, "isMusketer"))
	{
        GiveItem2Character(chref, "unarmed");
        EquipCharacterByItem(chref, "unarmed");
	}
	return "";
}

bool IsEquipCharacterByItem(ref chref, string itemID)
{
	aref arEquip;
	makearef(arEquip,chref.equip);
	int q = GetAttributesNum(arEquip);
	for(int i=0; i<q; i++)
	{	if(GetAttributeValue(GetAttributeN(arEquip,i))==itemID) return true;
	}
	return false;
}
//#20190114-01
bool IsEquipMusketItem(ref chref)
{
    string itemID;
    aref arItm;
    aref arEquip;

	makearef(arEquip,chref.equip);
	int q = GetAttributesNum(arEquip);
	for(int i=0; i<q; i++)
	{
	    itemID = GetAttributeValue(GetAttributeN(arEquip, i));
	    if(Items_FindItem(itemID, &arItm) < 0)
            continue;
        if(CheckAttribute(&arItm, "isMusket"))
            return true;
	}
    return false;
}

string GetCharacterEquipByGroup(ref chref, string groupID)
{
	if( CheckAttribute(chref,"equip."+groupID) ) return chref.equip.(groupID);
	return "";
}

string GetCharacterEquipPictureByGroup(ref chref, string groupID)
{
	string sItem = GetCharacterEquipByGroup(chref, groupID);
	for(int i = ITEMS_QUANTITY-1; i >= 0; i--)
	{
		if(items[i].id == sItem)
		{
			if(Items[i].id == "spyglass5")
			{
				Items[i].picIndex = 4;
			}
			return groupID + items[i].picIndex;
		}
	}
	return "";
}

void RemoveCharacterEquip(ref chref, string groupID)
{
	DeleteAttribute(chref,"equip."+groupID);
	SetEquipedItemToCharacter(chref,groupID,"");
	if(groupID == GUN_ITEM_TYPE)
    {
        LAi_GunSetChargeQuant(chref,0);
        bool isAlreadyMuskEq = IsEquipMusketItem(chref);
        if(isAlreadyMuskEq && CheckAttribute(chref, "model.oldmodel"))
        {
            DeleteAttribute(chref,"equip.blade");
            takeitemfromcharacter(chref,"unarmed");
            chref.items.unarmed = 0;
            chref.model = chref.oldmodel;
            chref.model.animation = chref.model.oldani;
            SetNewModelToChar(chref);
        }
    }
}

void RemoveOfficerEquip(ref chref, string groupID)
{
	string sItemID = chref.equip.(groupid);

	DeleteAttribute(chref,"equip."+groupID);
	SetEquipedItemToCharacter(chref,groupID,"");
	TakeItemFromCharacter(chref, sItemID);
	//GiveItem2Character(pchar, sItemID);
}

void SetEquipedItemToCharacter(ref chref, string groupID, string itemID)
{
    object emptyItm;
    aref arItm;
    string modelName = "";
    makearef(arItm,emptyItm);
    int itemNum;

    if(itemID!="")
    {
        if( !CheckCharacterItem(chref,itemID) ) return;
        itemNum = Items_FindItem(itemID,&arItm);
    }
    else
    {
        if(checkattribute(chref, "model.oldmodel") && groupID == GUN_ITEM_TYPE)
        {
            chref.model = chref.model.oldmodel;
            chref.model.animation = chref.model.oldani;
            SetNewModelToChar(chref);
        }
    }
    switch(groupID)
    {
    case SPYGLASS_ITEM_TYPE:
        if(CheckAttribute(arItm,"id"))
        {
            setTelescopeInitParameters(arItm);
        }
        break;
    //#20171102-01 Add hat/helmet
    case HEAD_ITEM_TYPE:
        if(CheckAttribute(arItm,"model"))
        {
            modelName = arItm.model;
            chref.headGearID = itemNum;
        }
        else {
             DeleteAttribute(chref, "headGearID");
        }
        //#20191007-01
        setHeadgearPos(chref, modelName);
        break;
    case CIRASS_ITEM_TYPE:
        if (CheckAttribute(chref, "HeroModel"))
        {
            if (CheckAttribute(arItm, "model"))
            {
// ---> Back84
                if(CheckAttribute(chref,"IsSkel"))
                {
                    chref.quest.tempmodel = GetSubStringByNum(chref.HeroModel, sti(arItm.model));
                } //#20190114-01
                else {
                    if(IsEquipMusketItem(chref))
                    {
                        chref.model.oldmodel = GetSubStringByNum(chref.HeroModel, sti(arItm.model));
                        chref.model = GetSubStringByNum(chref.HeroModel, sti(arItm.model)) + "_mush";
                    }
                    else
                    {
    //Boyer fix for non-cirass model entities like girdle, gloves, boots #20170318-56
                        //#20190113-03
                        if(!CheckAttribute(arItm, "skipPerkCheck")) {
                            chref.model = GetSubStringByNum(chref.HeroModel, sti(arItm.model));
                            //#20180103-02 Hero animation extension
                            if (CheckAttribute(chref, "HeroAnim"))
                                chref.model.animation = GetSubStringByNum(chref.HeroAnim, sti(arItm.model));
                        }
                    }
                }
// <--- Back84
                chref.cirassId = itemNum;
            }
            else
            {
// ---> Back84
                if(CheckAttribute(chref,"IsSkel"))
                {
                    chref.quest.tempmodel = GetSubStringByNum(chref.HeroModel, 0);
                } //#20190114-01
                else {
                    if(IsEquipMusketItem(chref))
                    {
                        chref.model.oldmodel = GetSubStringByNum(chref.HeroModel, 0);
                        chref.model = GetSubStringByNum(chref.HeroModel, 0) + "_mush";
                    }
                    else
                    {
    //Boyer fix for non-cirass model entities like girdle, gloves, boots #20170318-56
                        //#20190113-03
                        if(!CheckAttribute(arItm, "skipPerkCheck")) {
                            chref.model = GetSubStringByNum(chref.HeroModel, 0);
                            //#20180103-02 Hero animation extension
                            if (CheckAttribute(chref, "HeroAnim"))
                                chref.model.animation = GetSubStringByNum(chref.HeroAnim, 0);
                        }
                    }
                }
// <--- Back84
                DeleteAttribute(chref, "cirassId");
            }
        }
        else
        {
            if(CheckAttribute(arItm, "model"))
            {
                chref.cirassId = itemNum;
            }
            else
            {
                DeleteAttribute(chref, "cirassId");
            }
        }
        SetNewModelToChar(chref);
        break;
    case PATENT_ITEM_TYPE:
        if(CheckAttribute(arItm,"quest"))
        {
            DoQuestCheckDelay(arItm.quest, 1.0);
            chref.EquipedPatentId = itemNum;
        }
        else
        {
            DeleteAttribute(chref, "EquipedPatentId");
        }
        break;
    case GUN_ITEM_TYPE:
        if(CheckAttribute(arItm,"model"))
        {
            modelName = arItm.model;
        }
        SendMessage(chref,"ls",MSG_CHARACTER_SETGUN,modelName);
        //#20171211-01 Sound overrides for rifle types
        if(modelName != "")
            setGunshotSound(chref, arItm.id);
        if(CheckAttribute(arItm,"chargeQ"))
        {
            LAi_GunSetChargeQuant(chref,sti(arItm.chargeQ));
        }
        else
        {
            LAi_GunSetChargeQuant(chref,0);
        }
        if(CheckAttribute(arItm,"chargespeed") && stf(arItm.chargespeed)>0.0)
        {
            LAi_GunSetChargeSpeed(chref,1.0/stf(arItm.chargespeed));
        }
        else
        {
            LAi_GunSetChargeSpeed(chref,0.0);
        }
        if(CheckAttribute(arItm,"dmg_min"))
        {
            LAi_GunSetDamageMin(chref,stf(arItm.dmg_min));
        }
        else
        {
            LAi_GunSetDamageMin(chref,0.0);
        }
        if(CheckAttribute(arItm,"dmg_max"))
        {
            LAi_GunSetDamageMax(chref,stf(arItm.dmg_max));
        }
        else
        {
            LAi_GunSetDamageMax(chref,0.0);
        }
        if(CheckAttribute(arItm,"accuracy"))
        {
            LAi_GunSetAccuracy(chref,stf(arItm.accuracy)*0.01);
        }
        else
        {
            LAi_GunSetAccuracy(chref,0.0);
        }
        break;
    case BLADE_ITEM_TYPE:
        float liveTime = 0.1;
        int colors = argb(64, 64, 64, 64);
        int colore = argb(0, 32, 32, 32);
        if(CheckAttribute(arItm,"model"))
        {
            modelName = arItm.model;
        }
        //#20191009-01
        if(CheckAttribute(arItm, "param.time")) //"blade.time"))
        {
            liveTime = stf(arItm.param.time);
        }
        if(CheckAttribute(arItm, "param.colorstart")) //"blade.colorstart"))
        {
            colors = sti(arItm.param.colorstart);
        }
        if(CheckAttribute(arItm, "param.colorend")) //"blade.colorend"))
        {
            colore = sti(arItm.param.colorend);
        }
//SendMessage(chref, "lsfll", MSG_CHARACTER_SETBLADE, modelName, liveTime, colors, colore);

        SendMessage(chref, "llsfll", MSG_CHARACTER_SETBLADE, 0, modelName, liveTime, colors, colore);

        if(CheckAttribute(arItm,"dmg_min"))
        {
            LAi_BladeSetDamageMin(chref,stf(arItm.dmg_min));
        }
        else
        {
            LAi_BladeSetDamageMin(chref,0.0);
        }
        if(CheckAttribute(arItm,"dmg_max"))
        {
            LAi_BladeSetDamageMax(chref,stf(arItm.dmg_max));
        }
        else
        {
            LAi_BladeSetDamageMax(chref,0.0);
        }
        //#20191007-01
        if(CheckAttribute(arItm,"hitSound"))
        {
            LAi_BladeSetHitSound(chref,arItm.hitSound);
        }
        else
        {
            LAi_BladeSetHitSound(chref,"");
        }
        if(CheckAttribute(arItm,"piercing"))
        {
            LAi_BladeSetPiercing(chref,stf(arItm.piercing)*0.01);
        }
        else
        {
            LAi_BladeSetPiercing(chref,0.0);
        }
        if(CheckAttribute(arItm,"block"))
        {
            LAi_BladeSetBlock(chref,stf(arItm.block)*0.01);
        }
        else
        {
            LAi_BladeSetBlock(chref,0.0);
        }
        if(CheckAttribute(arItm,"FencingType"))
        {
            LAi_BladeFencingType(chref, arItm.FencingType);
        }
        else
        {
            LAi_BladeFencingType(chref, "Fencing");
        }
        if(CheckAttribute(arItm,"Weight"))
        {
            LAi_BladeEnergyType(chref, GetEnergyBladeDrain(stf(arItm.Weight)) );
        }
        break;
    }
}

float GetEnergyBladeDrain(float _weight)
{
    return _weight / 9.0 + 0.4;
}

void EquipCharacterByItem(ref chref, string itemID)
{
    aref arItm;
    if( !CheckCharacterItem(chref, itemID) ) return;
    if( Items_FindItem(itemID, &arItm)<0 ) return;
    if( !CheckAttribute(arItm, "groupID") ) return;

    string groupName = arItm.groupID;
    string oldItemID = GetCharacterEquipByGroup(chref, groupName);
    if(oldItemID==itemID) return;
// Back84 -->
    if(oldItemID == "unarmed")
    {
        removecharacterequip(chref,BLADE_ITEM_TYPE);
        takeitemfromcharacter(chref,"unarmed");
        chref.items.unarmed = 0;
    }
    bool isMusket = false;
    //#20190114-01 #20200228-03
    if(CheckAttribute(arItm, "isMusket"))
        isMusket = true;
    //#20171102-01 Add hat/helmet...#20200228-03 actually replace to just check gun or blade
    if (groupname == BLADE_ITEM_TYPE || groupname == GUN_ITEM_TYPE)
    {
        bool isAlreadyMuskEq = IsEquipMusketItem(chref);
        //#20190114-01 #20190729-01
        if(!isMusket && isAlreadyMuskEq && CheckAttribute(chref, "model.oldmodel"))
        {
            removecharacterequip(chref,GUN_ITEM_TYPE);
            chref.model = chref.model.oldmodel;
            chref.model.animation = chref.model.oldani;
            SetNewModelToChar(chref);
        }
    }
// <-- Back84
    bool bElseCheck = false;
    string sAni = strcut(chref.model.animation, 0, 8);
    bool bIsOff = false;
    if(IsOfficer(chref))
        bIsOff = true;
    if(!bIsOff && IsCompanion(chref))
        bIsOff = true;
    if (sAni == "mushketer")
    {
        //#20200228-03 Other chars may now possibly use mushketer animations
        if(!bIsOff) { //Non-officers cannot switch weapon from musket
            if (groupName == BLADE_ITEM_TYPE && itemID != "unarmed") return;
            //#20190114-01
            if(groupName == GUN_ITEM_TYPE) {
                if(!isMusket) return;
                if (chref.id == "OffMushketer" && itemID != "mushket2x2") return;
            }
        }
        else {
            if (chref.id == "OffMushketer") //Special quest char keeps special musket
            {
                if (groupName == GUN_ITEM_TYPE && itemID != "mushket2x2") return;
            }
            else {
                bElseCheck = true;
            }
            //else
            //{
            //    if (groupName == GUN_ITEM_TYPE && itemID != "mushket" && itemID != "mushket1") return;
            //}
        }
    }
    else {
        bElseCheck = true;
    }
    //#20200228-03
    if(bElseCheck) {
// Back84 -->
        if (groupName == GUN_ITEM_TYPE && isMusket)
        {
            if (sti(chref.index) == GetMainCharacterIndex() || bIsOff)
            {
                sAni = chref.model.animation;
                string sModel = chref.model;
                if(!GetINIString("pscripts\MusketAni.ini", sModel, &sAni))
                {
                    sModel = chref.model + "_mush";
                    if(!GetINIString("pscripts\MusketAni.ini", sModel, &sAni))
                        return;
                }
                if(!isAlreadyMuskEq) {
                    chref.model.oldmodel = chref.model;
                    chref.model.oldani = chref.model.animation;
                }
                chref.model = sModel;
                chref.model.animation = sAni;
                SetNewModelToChar(chref);
                if(!isequipcharacterbyitem(chref,"unarmed"))
                {
                    GiveItem2Character(chref, "unarmed");
                    EquipCharacterByItem(chref,"unarmed");
                }
            }
            else
            {
                return;
            }
        }
// <-- back84
    }
    chref.equip.(groupName) = itemID;

    if(IsEntity(chref))
    {
        SetEquipedItemToCharacter(chref, groupName, itemID);
    }
    if(groupName==GUN_ITEM_TYPE && sti(chref.index)==GetMainCharacterIndex())
    {
        LAi_GunSetUnload(chref);
    }
    //#20181023-01
    else { if (groupName == SPYGLASS_ITEM_TYPE && sti(chref.index)==GetMainCharacterIndex() && IsEntity(&objISpyGlass))
    {
        InterfaceSpyGlassRelease();
        InterfaceSpyGlassInit(false);
    }}
}

void EquipOfficerByItem(ref chref, string itemID)
{
	aref arItm;

	int iItemQuantity = 0;
	if( !CheckCharacterItem(chref, itemID))
	{
		iItemQuantity = GetCharacterItem(pchar);
		if(iItemQuantity == 1 && IsEquipCharacterByItem(pchar, itemID) == true)
		{
			return;
		}
		else
		{
			TakeItemFromCharacter(pchar, itemID);
			GiveItem2Character(chref, itemID);
		}
	}
	EquipCharacterByItem(chref, itemID);
	/*
	if( Items_FindItem(itemID, &arItm)<0 )	return;
	if( !CheckAttribute(arItm, "groupID") ) return;

	string groupName = arItm.groupID;
	string oldItemID = GetCharacterEquipByGroup(chref, groupName);
	if(oldItemID==itemID) return;
	chref.equip.(groupName) = itemID;

	if(IsEntity(chref))
	{	SetEquipedItemToCharacter(chref, groupName, itemID);
	}
	if(groupName==GUN_ITEM_TYPE && sti(chref.index)==GetMainCharacterIndex())
	{	LAi_GunSetUnload(chref);
	}
	*/
}

void ExecuteCharacterEquip(ref chref)
{
    aref arItm;
	string stmp = GetCharacterEquipByGroup(chref,BLADE_ITEM_TYPE);
	if(stmp!="")	{SetEquipedItemToCharacter(chref, BLADE_ITEM_TYPE, stmp);}
	stmp = GetCharacterEquipByGroup(chref,GUN_ITEM_TYPE);
    if(stmp!="")
    {
        SetEquipedItemToCharacter(chref, GUN_ITEM_TYPE, stmp);
        if(sti(chref.index)!=GetMainCharacterIndex() && !isOfficer(chref))
        {
            Items_FindItem(stmp,&arItm);
            if(CheckAttribute(arItm,"chargeQ"))
            {
                LAi_GunSetChargeQuant(chref,sti(arItm.chargeQ));
            }
            else
            {
                LAi_GunSetChargeQuant(chref,0);
            }
        }
    }
	//#20191010-01
	stmp = GetCharacterEquipByGroup(chref,HEAD_ITEM_TYPE);
	if(stmp!="")	{SetEquipedItemToCharacter(chref, HEAD_ITEM_TYPE, stmp);}
}

bool IsCanEquiping(ref chref, string equiping_group)
{
	if( CheckAttribute(chref,"equip.disabled_group."+equiping_group)
		&& sti(chref.equip.disabled_group.(equiping_group))==true ) return false;
	return true;
}
//Note: Does not appear used anywhere
void EnableEquip(ref chref, string equiping_group, bool enable)
{
	if(enable)
	{	if(equiping_group=="")
		{	DeleteAttribute(chref,"equip.disabled_group");
		}
		else
		{	DeleteAttribute(chref,"equip.disabled_group."+equiping_group);
		}
	}
	else
	{	if(equiping_group=="")
		{
			string stmp;
			stmp = GUN_ITEM_TYPE;		chref.equip.disabled_group.(stmp) = true;
			stmp = BLADE_ITEM_TYPE;		chref.equip.disabled_group.(stmp) = true;
			stmp = SPYGLASS_ITEM_TYPE;	chref.equip.disabled_group.(stmp) = true;
		}
		else
		{
			chref.equip.disabled_group.(equiping_group) = true;
		}
	}
}

int ChangeCharacterReputationABS(ref chref, float incr)
{
	int curVal = REPUTATION_NEUTRAL;
	if (CheckAttribute(chref,"reputation") ) curVal = stf(chref.reputation);

	if (curVal < REPUTATION_NEUTRAL) incr = -incr;
	return ChangeCharacterReputation(chref , incr);
}

int ChangeCharacterReputation(ref chref, float incr)
{
	if (CheckAttribute(chref, "GenQuest.ReputationNotChange")) return sti(chref.reputation);
	float prevVal = REPUTATION_NEUTRAL;
	if (CheckAttribute(chref,"reputation") )	prevVal = stf(chref.reputation);

	float newVal = prevVal + incr;
	if (newVal<REPUTATION_MIN) newVal = REPUTATION_MIN;
	if (newVal>REPUTATION_MAX) newVal = REPUTATION_MAX;
	chref.reputation = newVal;

	if( sti(chref.index) != GetMainCharacterIndex() ) return makeint(newVal);

	string prevName = GetReputationName(makeint(prevVal));
	string newName = GetReputationName(makeint(newVal));
	if (prevName!=newName)
	{
		string outString = XI_ConvertString("Your reputation")+" ";
		if (incr>0)	{outString+=XI_ConvertString("increase");}
		else	{outString+=XI_ConvertString("decrease");}
		outString += " "+XI_ConvertString("to")+" "+XI_ConvertString(newName);
		Log_SetStringToLog(outString);
	}
	return makeint(newVal);
}

void UpdateFame()
{
	if (sti(pchar.reputation) < (REPUTATION_NEUTRAL - 10))
	{
		ChangeCharacterReputation(pchar, (MOD_SKILL_ENEMY_RATE / 40.0));
	}
	if (sti(pchar.reputation) > (REPUTATION_NEUTRAL + 10))
	{
		ChangeCharacterReputation(pchar, (-MOD_SKILL_ENEMY_RATE / 20.0));
	}
}

bool Character_IsAbordageEnable(ref rCharacter)
{
	if (CheckAttribute(rCharacter, "AlwaysFriend")) return false;
	if (CheckAttribute(rCharacter, "Abordage.Enable")) { return sti(rCharacter.Abordage.Enable); }
	return true;
}

void Character_SetAbordageEnable(ref rCharacter, bool bEnable)
{
	rCharacter.Abordage.Enable = bEnable;
}

void Character_SetCompanionEnemyEnable(ref rCharacter, bool bEnable)
{
	rCharacter.CompanionEnemyEnable = bEnable;
}

void AddMsgToCharacter(ref chref, int nMsg)
{
    //Boyer remove, useless in Storm 2.8
	/*
	string msgName = "msg"+nMsg;
	bool bStartEvent = !CheckAttribute(chref,"MessageIcons."+msgName);
	chref.MessageIcons.(msgName).pic = nMsg;
	chref.MessageIcons.(msgName) = MSGICON_ACTIVE_TIME;
	if(bStartEvent) PostEvent("evnt_MsgIconTick",1000,"ll",nMsg,sti(chref.index));
    */
}

void DelMsgFromCharacter(ref chref, int nMsg)
{
	//Boyer remove, useless in Storm 2.8
	//DeleteAttribute(chref,"MessageIcons.msg"+nMsg);
}
//Boyer remove, useless in Storm 2.8
/*
void proc_MsgIconTick()
{
	int nMsg = GetEventData();
	int chrIdx = GetEventData();
	if(DialogRun!=0) {
		PostEvent("evnt_MsgIconTick",1000,"ll",nMsg,chrIdx);
		return;
	}
	ref chref = GetCharacter(chrIdx);
	string msgName = "msg"+nMsg;
	int nTime = 0;

	if( CheckAttribute(chref,"MessageIcons."+msgName) )
	{
		nTime = sti(chref.MessageIcons.(msgName));
		if(nTime>0)
		{
			chref.MessageIcons.(msgName) = nTime-1;
			PostEvent("evnt_MsgIconTick",1000,"ll",nMsg,chrIdx);
			return;
		}
		DelMsgFromCharacter(chref,nMsg);
	}
}
*/
string  Get_My_Cabin()
{
	return Pchar.SystemInfo.CabinType;
}

string  Get_My_Cabin_Pic()
{
    int  i;

    i = FindLocation(Pchar.SystemInfo.CabinType);
    if (i != -1)
    {
    	return   Locations[i].image;
    }
	return "";
}
bool isShipInside(string _id)
{
    bool   ret = false;

    if (_id == Get_My_Cabin() || _id == "My_Deck_Medium" || _id == "My_Campus" || _id == "My_Deck" || _id == "Deck_Near_Ship")
    {
        ret = true;
        if (CheckAttribute(pchar, "GenQuest.DestroyPirate") && CheckAttribute(pchar, "GenQuest.CaptainId") && pchar.GenQuest.CaptainId == "MQPirate")
	    {
	        if (!CheckQuestAttribute("Munity", "Deads")) ret = false;
	    }
    }
    return ret;
}
void  Set_My_Cabin()
{
    int     n,i;
    string  sTemp, newCab;
    ref     rShip;

    int nShipType = GetCharacterShipType(pchar);
	if (nShipType == SHIP_NOTUSED)
	{
        newCab = "My_Cabin";
	}
	else
	{
	    rShip = GetRealShip(nShipType);
	    newCab = "My_" + rShip.CabinType;
	}

    if (Pchar.SystemInfo.CabinType != newCab)
    {
        if (Pchar.SystemInfo.CabinType != "")
        {
            ref     loc, locTo;
            aref    arFromBox;
            aref    curItem;
	        string  attr;

            loc   = &locations[FindLocation(Pchar.SystemInfo.CabinType)];
            locTo = &locations[FindLocation(newCab)];
            locTo.box1.money = 0;
            for (n = 1; n <= 4; n++)
            {
                sTemp = "box" + n;

                if (CheckAttribute(loc, sTemp + ".money"))
                {
                    locTo.box1.money = sti(locTo.box1.money) + sti(loc.(sTemp).money);
                }
                makearef(arFromBox, loc.(sTemp).items);
                for(i=0; i<GetAttributesNum(arFromBox); i++)
                {
                    curItem = GetAttributeN(arFromBox, i);
                    attr = GetAttributeName(curItem);
                    if (attr != "")
                    {
                        if (!CheckAttribute(locTo, "box1.items." + attr))
                        {
                            locTo.box1.items.(attr) = 0;
                        }
                        locTo.box1.items.(attr) = makeint(sti(locTo.box1.items.(attr)) + makeint(GetAttributeValue(curItem)));
                    }
                }
                // del
        		DeleteAttribute(loc, sTemp + ".items");
        	    loc.(sTemp).items = "";
        	    loc.(sTemp) = Items_MakeTime(0, 0, 1, 2003);
        	    loc.(sTemp).money = 0;
            }
        }
        Pchar.SystemInfo.CabinType = newCab;
        n = FindLocation("My_Deck");
        if (n != -1)
        {
            if (nShipType != SHIP_NOTUSED && sti(rShip.Class) > SHIP_CLASS_4)
            {
                //#20170705-01 Add new cabins, hold
                setHoldA(&Locations[n]);
                Locations[n].reload.l1.go = Pchar.SystemInfo.CabinType;
                Locations[n].reload.l1.emerge = "reload1";
            }
            else
            {
                //#20170705-01 Add new cabins, hold
                setHoldB(&Locations[n]);
                Locations[n].reload.l1.go = "My_Deck_Medium";
                Locations[n].reload.l1.emerge = "reload_hold";
            }
        }
        n = FindLocation(Pchar.SystemInfo.CabinType);
        if (n != -1)
        {
            if (nShipType != SHIP_NOTUSED && sti(rShip.Class) > SHIP_CLASS_4)
            {
                Locations[n].reload.l1.go = "My_Deck";
                Locations[n].reload.l1.emerge = "reload1";
            }
            else
            {
                Locations[n].reload.l1.go = "My_Deck_Medium";
                Locations[n].reload.l1.emerge = "reload_cabin";
            }
        }
        n = FindLocation("My_Deck_Medium");
        if (n != -1)
        {
            Locations[n].reload.l1.go = Pchar.SystemInfo.CabinType;
        }
    }
}

bool isMainCharacterPatented()
{
    if(CheckAttribute(pchar, "EquipedPatentId") && CheckCharacterItem(pchar, Items[sti(pchar.EquipedPatentId)].id))
    {
        return true;
    }
    return false;
}

int GetPatentNation()
{
    if(CheckAttribute(pchar, "EquipedPatentId") && CheckCharacterItem(pchar, Items[sti(pchar.EquipedPatentId)].id))
    {
        return sti(Items[sti(pchar.EquipedPatentId)].Nation);
    }
    return -1;
}

void AddTitleNextRate(int nation, float num)
{
    if (isMainCharacterPatented() && sti(Items[sti(pchar.EquipedPatentId)].Nation) == nation)
    {
        Items[sti(pchar.EquipedPatentId)].TitulCurNext = stf(Items[sti(pchar.EquipedPatentId)].TitulCurNext) + num;
        if (stf(Items[sti(pchar.EquipedPatentId)].TitulCurNext) < 0) Items[sti(pchar.EquipedPatentId)].TitulCurNext = 0;
        if (stf(Items[sti(pchar.EquipedPatentId)].TitulCurNext) > MAX_TITLENEXTRATE) Items[sti(pchar.EquipedPatentId)].TitulCurNext = MAX_TITLENEXTRATE;
        Log_TestInfo("TitleCurNext = " + stf(Items[sti(pchar.EquipedPatentId)].TitulCurNext));
    }
}

bool isReadyToNextTitle(int nation)
{
    bool    ret = false;

    if (isMainCharacterPatented() && sti(Items[sti(pchar.EquipedPatentId)].Nation) == nation)
    {
        if (sti(Items[sti(pchar.EquipedPatentId)].TitulCur) < MAX_TITLE && (stf(Items[sti(pchar.EquipedPatentId)].TitulCurNext) / sti(Items[sti(pchar.EquipedPatentId)].TitulCur)) >= MAX_TITLE_STEP)
        {
            ret = true;
        }
    }
    return ret;
}

float GetCardsGameCheckRate()
{
	float k;
	float   fWin, fLose;


	fWin  = makefloat(Statistic_AddValue(Pchar, "GameCards_Win", 0));
    fLose = makefloat(Statistic_AddValue(Pchar, "GameCards_Lose", 0));
    if (fLose < 1) fLose = 1.0;

    k = fWin / fLose;

	return k;
}
bool CheckCardsGameSmallRate()
{
	bool    ret = true;

    if (GetCardsGameCheckRate() >= 15)
    {
        ret = false;
    }
	return ret;
}

bool CheckCardsGameBigRate()
{
	bool    ret = true;

    if (GetCardsGameCheckRate() >= 7)
    {
        ret = false;
    }
	return ret;
}

float GetDiceGameCheckRate()
{
	float k;
	float   fWin, fLose;

	fWin  = makefloat(Statistic_AddValue(Pchar, "GameDice_Win", 0));
    fLose = makefloat(Statistic_AddValue(Pchar, "GameDice_Lose", 0));
    if (fLose < 1) fLose = 1.0;

    k = fWin / fLose;

	return k;
}
bool CheckDiceGameSmallRate()
{
	bool    ret = true;

    if (GetDiceGameCheckRate() >= 15)
    {
        ret = false;
    }
	return ret;
}

bool CheckDiceGameBigRate()
{
	bool    ret = true;

    if (GetDiceGameCheckRate() >= 7)
    {
        ret = false;
    }
	return ret;
}

int GetPartyCrewQuantity(ref _refCharacter, bool _removable)
{
	int cn;
	int sumCrew = 0;
	ref officer;

	for(int i=0; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if (cn!=-1)
		{
            officer = GetCharacter(cn);
            if (!GetRemovable(officer) && _removable) continue;
			sumCrew = sumCrew + GetCrewQuantity(officer);
		}
	}
	return sumCrew;
}

int GetTroopersCrewQuantity(ref _refCharacter)
{
	int cn, j;
	int compCrew;
	int sumCrew = 0;
	ref officer;

 	if (CheckOfficersPerk(_refCharacter, "Troopers"))
    {
        Log_TestInfo("-= GetTroopersCrewQuantit =-");
        for (j=1; j<COMPANION_MAX; j++)
        {
	        cn = GetCompanionIndex(_refCharacter, j);
	        if (cn>0)
	        {
		        officer = GetCharacter(cn);
		        if (!GetRemovable(officer)) continue;

		        compCrew = GetCrewQuantity(officer) - GetMinCrewQuantity(officer);
		        if (compCrew < 0)
		        {
		           compCrew = 0;
		        }
				compCrew = GetWeaponCrew(officer, compCrew);

                if (compCrew > 0)
                {
	                RemoveCharacterGoodsSelf(officer, GOOD_WEAPON, makeint(compCrew/2 + 0.5));
	                SetCrewQuantity(officer, GetCrewQuantity(officer) - compCrew);
                	Log_SetStringToLog(xiStr("MSG_RPG_7") + officer.Ship.Name + xiStr("MSG_RPG_8") + compCrew + xiStr("MSG_RPG_9"));
                	AddCharacterExpToSkill(officer, "Defence", makeint(compCrew / 2 + 0.5));
                	AddCharacterExpToSkill(officer, "Grappling", makeint(compCrew / 2 + 0.5));
                	sumCrew = sumCrew + compCrew;
                }
		    }
		}
    }
    if (CheckAttribute(_refCharacter, "TempPerks.QuestTroopers"))
	{
        Log_TestInfo("-= QuestTroopers =-");
		for (j=1; j<COMPANION_MAX; j++)
        {
	        cn = GetCompanionIndex(_refCharacter, j);
	        if (cn>0)
	        {
		        officer = GetCharacter(cn);
		        if (GetRemovable(officer)) continue;

		        compCrew = GetCrewQuantity(officer);
		        if (compCrew < 0)
		        {
		           compCrew = 0;
		        }
		        Log_SetStringToLog(xiStr("MSG_RPG_7") + officer.Ship.Name + xiStr("MSG_RPG_8") + compCrew + xiStr("MSG_RPG_9"));
                if (compCrew > 0)
                {
                	sumCrew = sumCrew + compCrew;
                }
		    }
		}
		DeleteAttribute(_refCharacter, "TempPerks.QuestTroopers");
	}
	return sumCrew;
}

void AddTroopersCrewToOther(ref _refCharacter)
{
	int cn, j;
	int compCrew;
	int sumCrew = 0;
	ref officer;

    compCrew = 0;
    if (GetMaxCrewQuantity(_refCharacter) < GetCrewQuantity(_refCharacter))
    {
        compCrew = GetCrewQuantity(_refCharacter) - GetMaxCrewQuantity(_refCharacter);
        SetCrewQuantity(_refCharacter, GetMaxCrewQuantity(_refCharacter));
    }
	if (compCrew > 0)
	{
	    for (j=1; j<COMPANION_MAX; j++)
	    {
	        cn = GetCompanionIndex(_refCharacter, j);
	        if (cn>0)
	        {
		        officer = GetCharacter(cn);
		        if (!GetRemovable(officer)) continue;

                if (GetMaxCrewQuantity(officer) >= (GetCrewQuantity(officer) + compCrew))
                {
                    SetCrewQuantity(officer, (GetCrewQuantity(officer) + compCrew));
                    break;
                }
                else
                {
                    compCrew = (GetCrewQuantity(officer) + compCrew) - GetMaxCrewQuantity(officer);
                    SetCrewQuantity(officer, GetMaxCrewQuantity(officer));
                }
		    }
		}
	}
}

int GetWeaponCrew(ref _char, int allcrew) // EDITED on 27.12.2022 by Vadim C.
{
	// A FIX for an incomplete (enemy ship cargo) fix in (AIFantom.c) to set a new amount of weapons available on all enemy ships.
	// NOTE: To complete this fix, we need to make sure that enemy ships have free space for all additional required weapons.
	// However freeing extra space may also be bad, since we don't know what to throw out. And some randomness feels more natural.
	
	if(allcrew <= 0) {
		allcrew = sti(GetCrewQuantity(_char));
	}
	
	int armed;
	int weapons = sti(GetCargoGoods(_char, GOOD_WEAPON));
	float reinforcements = 0.5;// 50% reinforcements
	if(weapons > 0) {
		if (allcrew > weapons) {
			// since the (enemy ship cargo) fix isn't complete, we'll add 50% of the rest of the crew to the fight that don't have weapons.
			armed = weapons + makeint((allcrew - weapons) * reinforcements);
		} else {
			armed = allcrew;// all 100% of the crew are able use the available weapons and put up a good fight!
		}
	} else {
		armed = allcrew / 5;// only 20% of the crew will be able to fight with pretty much no weapons available
	}
	return makeint(armed);
	
    /*int weaponOnBoard = GetCargoGoods(_char, GOOD_WEAPON);
	if (_crew > weaponOnBoard)
	{
	    _crew = weaponOnBoard + makeint(( _crew - weaponOnBoard)/2.0 + 0.5);
	}
	return makeint(_crew);
	*/
}

int GenerateNationTrade(int nation)
{
	int i = -1;
	int   j = 0;
	bool  ok;
	int maxTries = MAX_NATIONS * 2;

	while (i == -1 && j < maxTries)
	{
		i = rand(MAX_NATIONS - 1);
		ok = (GetNationRelation2MainCharacter(i) == RELATION_ENEMY) && (i != PIRATE); //fix 12.05.05
		if (ok || GetNationRelation(nation, i) == RELATION_ENEMY)  // nation == i || i == PIRATE
		{
			i = -1;
		}
		j++;
	}
	return i;
}

int RecalculateSquadronCargoLoad(ref _refCharacter)
{
	int i,cn;
	int retVal = RecalculateCargoLoad(_refCharacter);

	for(i=1; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if(cn!=-1)
		{
			retVal = retVal + RecalculateCargoLoad(&Characters[cn]);
		}
	}
	return retVal;
}

void LoansMoneyAvenger(ref _loan)
{
    Log_SetStringToLog(xiStr("MSG_RPG_10"));

    LoansMoneyAvengerAmount(_loan, 25);
}

void LoansMoneyAvengerAmount(ref _loan, int _sum)
{
    string typeHunter = NationShortName(sti(_loan.nation)) + "hunter";
    ChangeCharacterReputation(Pchar, -20);
    OfficersReaction("bad");
    if ( _loan.nation == PIRATE)
    {
        typeHunter = "enghunter";
    }
    ChangeCharacterHunterScore(PChar, typeHunter, _sum);
}

int GetCharacterbyLocation(string location, string group, string locator)
{
    ref sld;
    for(int i=0;i<MAX_CHARACTERS;i++)
	{
        sld = &characters[i];
        if (sld.location == location && sld.location.group == group && sld.location.locator == locator) return i;
	}
	return -1;
}

void OfficersHold()
{
	int idx;
	//#20170318-20
	for(int i=1; i<=MAX_NUM_FIGHTERS; i++)
	{
		idx = GetOfficersIndex(PChar,i);
		if (idx != -1) {
			ref offchar = GetCharacter(idx);
			SetCharacterTask_Stay(offchar);
		}
	}
}

void OfficersFollow()
{
	int idx;
	//#20170318-20
	for(int i=1; i<=MAX_NUM_FIGHTERS; i++)
	{
		idx = GetOfficersIndex(PChar,i);
		if (idx != -1) {
			ref offchar = GetCharacter(idx);
			LAi_tmpl_SetFollow(offchar, GetMainCharacter(), -1.0);
		}
	}
}

//#20170705-01 Add new cabins, hold
void setHoldA(ref holdLocation)
{
    holdLocation.filespath.models = "locations\decks\hold";
	//holdLocation.image = "loading\Hold.tga.tx";
	//Sound
	//holdLocation.type = "cargo_hold"; // nc_mod

	//Models
	//Always
	holdLocation.models.always.locators = "hold_l";
	holdLocation.models.always.l1 = "hold";
	//Day
	holdLocation.models.day.charactersPatch = "hold_p";
	holdLocation.models.day.fonar = "hold_fd";
	//Night
	holdLocation.models.night.charactersPatch = "hold_p";
	holdLocation.models.night.fonar = "hold_fn";
}

void setHoldB(ref holdLocation)
{
    holdLocation.filespath.models = "locations\decks\Holdb";
	//holdLocation.image = "loading\Hold.tga.tx";
	//Sound
	//holdLocation.type = "cargo_hold"; // nc_mod

	//Models
	//Always
	holdLocation.models.always.locators = "holdb_l";
	holdLocation.models.always.l1 = "holdb";
	//Day
	holdLocation.models.day.charactersPatch = "holdb_p";
	holdLocation.models.day.fonar = "holdb_fd";
	//Night
	holdLocation.models.night.charactersPatch = "holdb_p";
	holdLocation.models.night.fonar = "holdb_fn";
}

//#20171211-01 Sound overrides for rifle types
void setGunshotSound(ref chref, string itemID)
{
    string sShotAction = "Shot"; //RifleShot, Matchshot

    if(itemID == "")
        return;
    if(!CheckAttribute(chref, "actions.shot"))
        return;
    string sAni = strcut(chref.model.animation, 0, 8);
    if (sAni == "mushketer")
        return;

    switch(itemID) {
        case "mushket":
            sShotAction = "RifleShot"
        break;
        case "mushket1":
            sShotAction = "RifleShot"
        break;
        case "mushket2x2":
            sShotAction = "RifleShot"
        break;
        case "pistol7": //Teno shotgun
            sShotAction = "RifleShot"
        break;
        case "pistol19": //Matchlock Arquebus
            sShotAction = "MatchShot"
        break;
    }
    if(chref.actions.shot == sShotAction)
        return;
    //From characters.c
    BeginChangeCharacterActions(chref);
    SetDefaultStayIdle(chref);
    if(GetItemsWeight(chref) > GetMaxItemsWeight(chref))
    {
        chref.actions.walk = "walk";
        chref.actions.backwalk = "back walk";
        chref.actions.run = "walk";
        chref.actions.backrun = "back run";
        chref.actions.stsUp = "stairs up";
        chref.actions.stsUpRun = "stairs up";
        chref.actions.stsDown = "stairs down";
        chref.actions.stsDownRun = "stairs down";
        chref.actions.fightwalk = "fight walk";
        chref.actions.fightbackwalk = "fight back walk";
        chref.actions.fightrun = "fight walk";
        chref.actions.fightbackrun = "fight back walk";
    }
    else
    {
        SetDefaultNormWalk(chref);
        SetDefaultFight(chref);
    }
    SetDefaultDead(chref);
    SetDefaultFightDead(chref);
    pchar.actions.shot = sShotAction;
    EndChangeCharacterActions(chref);
}
//#20191007-01
void setHeadgearPos(ref chr, string modelName)
{
    if(!CheckAttribute(chr, "model")) return;

    SendMessage(chr,"lsss",MSG_CHARACTER_SETHEAD, chr.model, modelName, "pscripts\HeadGear.ini");
}
//Boyer mod #20170318-25 for applying item equip logic after an officer receives new perk
void CharacterCheckEquipAll(ref refCharacter)
{

	if(!CheckAttribute(refCharacter, "id")) return;
	//The following is derived from itemstrade.c and itemsbox.c
	//Calls functions in CharacterUtilite.c to apply logic to equip item from refCharacter's inventory
	if (CheckAttribute(refCharacter, "skill.Fencing")) {
		EquipCharacterByItem(refCharacter, FindCharacterItemByGroup(refCharacter,BLADE_ITEM_TYPE));
		if (GetCharacterSkill(refCharacter,"Fencing") > 0.1) {
            EquipCharacterByItem(refCharacter, FindCharacterItemByGroup(refCharacter,CIRASS_ITEM_TYPE));
            //#20171102-01 Add hat/helmet
            EquipCharacterByItem(refCharacter, FindCharacterItemByGroup(refCharacter,HEAD_ITEM_TYPE));
		}
	}
	if (CheckAttribute(refCharacter, "skill.Pistol") && GetCharacterSkill(refCharacter,"Pistol") > 0.1 )
	{
		EquipCharacterByItem(refCharacter, FindCharacterItemByGroup(refCharacter,GUN_ITEM_TYPE));
	}
}
