#include "sound.h"
#include "messages.h"
#include "sound.c"

string savefile_info = "ver 1.0.7";
//#20190817-01
#define MAX_CHARS_IN_LOC	964 //84

//--------------------------------------------------------------------
// World Config section
//--------------------------------------------------------------------

int iRealDeltaTime = 0;
int iRealYear = 0;
int iRealMonth = 0;
int iRealDay = 0;

int iGrassQuality = 0; //0 full, 1 middle, 2 low, 3 off

int iEncountersRate = 1;
int	iArcadeSails = 1;   // GetRSRollSpeed

//--------------------------------------------------------------------
// Math section
//--------------------------------------------------------------------
#define PI		3.14159265
#define PIm2	6.28318530
#define PId2	1.57079632
#define INVALID_SOUND_ID	0
//#20190311-02
#define PERK_BASE_REPEL_BRD 35.0
#define WAIT_REPEL_TIME 85.0

int ngMusicID = 0;
string sgMusicName = "?";

float FRAND(float _x) { return rand(32768) / 32768.0 * _x; }
float frandSmall(float _x) { return rand(32) / 32.0 * _x; }

ref pchar;

//--------------------------------------------------------------------
// Bool section
//--------------------------------------------------------------------
#define false			0
#define true			1

//--------------------------------------------------------------------
// Nation section
//--------------------------------------------------------------------
 //#20180713-01 New Portugal nation
#define	MAX_NATIONS       6
#define MAX_NATIONS_SQR   36

#define ENGLAND		0
#define FRANCE		1
#define SPAIN		2
#define HOLLAND		3
#define PIRATE		4
#define PORTUGAL         5
#define PRIVATEER_NATION 8

#define NEUTRAL_NATION	9 //for surrendered ships

object	Nations[MAX_NATIONS];
int		NationsRelations[MAX_NATIONS_SQR];
int		NationsRelations2MainCharacter[MAX_NATIONS];

object	Render;

//--------------------------------------------------------------------
// Characters section
//--------------------------------------------------------------------
int     GlobalCharacters = 0;
int     MAX_CHARACTERS   = 10;
#define LOC_FANTOM_CHARACTERS		870	//32 max
#define FANTOM_CHARACTERS           940 //See ship.cpp
#define TOTAL_CHARACTERS			1000  // BOAT_CHARACTER  TOTAL_CHARACTERS - 1
#define BOAT_CHARACTER               999

#define MAX_LOCATIONS		799 //722 // nc_mod - two cabins added (each composed of 2 locations) - previous value: 700
#define MAX_ISLANDS   30
#define MAX_COLONIES  35

#define LSC_MAX_TAVERN		12
#define LSC_MAX_RESIDENCE	3
#define LSC_MAX_CHURCH		7
#define LSC_MAX_PRISON		3
#define LSC_MAX_STORE		3

//#20180527-02...move from locations_loader.c
#define MAX_SHIPS_IN_LOCATION	32

string 	sEnManNames[10], sEnWomenNames[4], sEnFamilies[108];
string 	sHoManNames[39], sHoWomenNames[14], sHoFamilies[95];
string 	sFrManNames[18], sFrWomenNames[17], sFrFamilies[158];
string 	sSpManNames[42], sSpWomenNames[16], sSpFamilies[66];

object  	NullCharacter;
object	Characters[TOTAL_CHARACTERS];
object	Locations[MAX_LOCATIONS];
object	Islands[MAX_ISLANDS];
object	Colonies[MAX_COLONIES];

object  	Environment;
int		nMainCharacterIndex = 1;//-1;
int		iNumFantoms;

int		nLocationsNum;
int		nTeleportLocation;
string	sTeleportLocName;
string  sTeleportLocator;

object SeaParametrs;

int MaxVertices = 32000; //unused
int MaxIndices = 33200; //unused
float GridStepX = 0.1;
float GridStepPC = 0.1;
float MaxWaveDistance = 4000.0; //unused
float LodScale = 0.7; //0.22; //0.7;//0.7;//1.2;//2.0;//4.0

ref GetFantomCharacter(int iIndex)
{
	return &Characters[FANTOM_CHARACTERS + iIndex];
}

ref GetCharacter(int iIndex)
{
    if (iIndex < 0 || iIndex >= TOTAL_CHARACTERS)
	{
		trace("Incorrect Index for a character! Wrong Index is " + iIndex);
		//if (MOD_BETTATESTMODE	==	"On") Log_Info("ERROR: Incorrect Index for a character! Wrong Index is " + iIndex);
		return &NullCharacter;
	}
	return &Characters[iIndex];
}

ref GetMainCharacter()
{
	return &Characters[nMainCharacterIndex];
}

int GetMainCharacterIndex()
{
	return nMainCharacterIndex;
}

int	GetCharacterIndex(string string_id)
{
	return NativeFindCharacter(&Characters, string_id);
}

void SetMainCharacterIndex(int index)
{
	if (nMainCharacterIndex!=-1)
	{
		Characters[nMainCharacterIndex].MainCharacter = "0";
		Characters[nMainCharacterIndex].model.entity = "NPCharacter";
	}
	nMainCharacterIndex = index;
	Characters[nMainCharacterIndex].MainCharacter = "1";
	Characters[nMainCharacterIndex].model.entity = "Player";
	pchar = GetMainCharacter();
}

#event_handler("GOpt_GetGrassQuality","EventReturn_iGrassQuality");

int EventReturn_iGrassQuality()
{
    //trace("GrassQuality");
    //#20191129-04
    if (bSeaActive && bStorm && iGrassQuality < 2) { return 2; } //Low
	return iGrassQuality;
}

#event_handler("GOpt_isGrassLightsOn","EventReturn_isGrassLightsOn");

int EventReturn_isGrassLightsOn()
{
	// trace("EventReturn_isGrassLightsOn");
	// 1 , 0
	if (bSeaActive || bStorm || bTornado)
	{
		return 0;
	}
	if (GetHour() >= 9 && GetHour() <= 18)
	{
	    return 1;
	}
	return 0;
}
